/***************************************************************************************************************************************/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  									 							      **/
/**  							 Graphical MaxEnt							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  							    (possibly) 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/










/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  						Name a bad programming habbit.							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  							We have it.								      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/








/*****************************************************************************************************************************************/
/** 						 CHANGELOG (after release 0.3)								**/
/*****************************************************************************************************************************************/
/** 																 	**/
/** Release 0.4 : - Adjust interval for writing out info in the non-verbose mode 							**/
/** 		  - Add TIME keyword 													**/
/** 	 	  - Add keywords GRAFirst and GRALevel for adjusting contouring of sections plotted with PGPLOT				**/
/** 	 	  - Add support for insertion of comments (preceded by #!*) in keyworded input files					**/
/** 	 																**/
/** Release 0.5 : - Keyword SHOW added to include a column with the value of entropy. 							**/
/** 	 	  - Attempt to incorporate an `informative' prior in Patterson function calculations : keyword PRIOr.			**/
/** 	 	    NOT VERY USEFUL (and very broken for non-primitive lattices).							**/
/** 	 	  - Keyword PHASeless <f> added to allow `free' phase refinement for reflections with low FOM.				**/
/** 		  - Square F000 internally in the case of Patterson function calculation						**/
/** 		  - Comments added to MAXENT_AUTO.IN											**/
/** 		  - LIMIT 0.5 is the default for Patterson function calculations							**/
/** 		  - Adjust target chi**2 value when PHASEless reflections are present 							**/
/** 	 	  - Add SWITch <f> keyword to allow switching to a phaseless calculation						**/
/** 	 	  - PSOUt keyword added to allow postscript output of sections (both conventional and maxent)				**/
/** 	 																**/
/** 	 																**/
/*****************************************************************************************************************************************/











#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <limits.h>
#include <unistd.h>
#include <signal.h>
#include <srfftw.h>




#include "matrix.dat"		/* this contains the correspondence between (F/sigF, FOM) and the major axes of the best ellipsoid */
				/* that fits the probability distribution function defined by the given (F/sigF, FOM) */
				






				/* Hmmm ... */
				/* I don't think that these can save us from serious troubles with VMS */
								
#ifdef VMS
#define 	strncasecmp 	strncmp
#define 	strcasecmp 	strcmp
#define		random 		rand
#define 	srandom 	srand 
#define		MAXRAND 	((float)(RAND_MAX)+1.0)
#endif




#ifndef VMS
#include <malloc.h>
#define		MAXRAND		((float)(INT_MAX)+1.0)
#endif



					
#define		GRID_FINE 	6.000		/* Grid size is [GRID_FINE x max(index)] rounded to the closest "good" FFT number  */
#define		MAX_NOF_REFL	60000
#define		MAX_REJ		1000
#define		LOG2(a)		(log10((double)(a))/log10(2.0))
#define         PI              (double)(3.14159265358979323846)
#define         PI2             (double)(1.57079632679489661923)
#define         PI4             (double)(0.78539816339744830962)
#define         min(a,b,c)      ((a)<=(b) && (a)<=(c) ? (a) : ((b)<=(c) ? (b) : (c)))
#define         max(a,b,c)      ((a)>=(b) && (a)>=(c) ? (a) : ((b)>=(c) ? (b) : (c)))
#define         max2(a,b)       ((a) >= (b) ? (a) : (b))
#define         min2(a,b)       ((a) <= (b) ? (a) : (b))
#define         getrand         ((float)(random())/MAXRAND)
#define         nearint(a)      ((a) < 0.0 ? (int)(a-0.50) : (int)(a+0.50))
#define		SQRT2 		(double)(1.414213562373095048801688724209698)   /* thanks to gnu, bc, dc and their arbitrary precision */

#define		GETTABLEVAL(n)	((int)(n)==0?0.010000:(  (int)(n)==1?0.01000*SQRT2:((int)(n)%2?(0.01000000*SQRT2*(2<<((int)(n)/2-1))):(0.01000000*(2<<((int)(n)/2-1))))))
												/* I can't read this either */






/**********************************************************************************************************************************/
/**   FFT definitions                                                                                                            **/
/**********************************************************************************************************************************/
rfftwnd_plan	p, pinv;
#define		SWAP(a,b)	tempr=(a) ; (a)=(b) ; (b)=tempr
#define 	FREE_ARG 	char*
#define		NR_END		1
#define		FORWARD		1
#define		INVERSE	       -1


/* Good (small prime) FFT numbers */

int good_numbers[51] = {
       1,       2,       4,       6,       8,      10,
      12,      14,      16,      20,      24,      28,
      30,      32,      40,      42,      48,      56,
      60,      64,      70,      80,      84,      96,
     112,     120,     128,     140,     160,     168,
     192,     210,     224,     240,     256,     280,
     320,     336,     384,     420,     448,     480,
     512,     560,     640,     672,     768,     840,
     896,     960,    1024  };
     
int	get_grid();     
     






/**********************************************************************************************************************************/
/**   MaxEnt definitions                                                                                                         **/
/**********************************************************************************************************************************/

float		CON	=	0.4000;		/* This is the assumed mean electron density of your (protein) crystals in e/A^3 */

/* Well, maybe not only maxent */
#define		YES		1
#define		NO		0









/**********************************************************************************************************************************/
/**   Other functions                                                                                                            **/
/**********************************************************************************************************************************/
float	maxent();
void	write_map();
void 	abortp();
void 	extram();
void	get_param();
void    polint(float xa[], float ya[], int n, float x, float *y, float *dy);
void    free_vector();
void	tona4();
void	plot_section();
void  	free_matrix();
void 	free_f3tensor();
float	**matrix( long nrl, long nrh, long ncl, long nch );
float	***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh );
void    nrerror( char error_text[]);
float   *vector();
void	normprob();
double  fact();
double  findx();





/**********************************************************************************************************************************/
/**   For plot_section()	                                                                                                 **/
/**********************************************************************************************************************************/
float	xmax, xmin, ymax, ymin;
float	angle;	
float 	tr[6];
float	cellf, cellm;
float	aspect;








/**********************************************************************************************************************************/
/**  Other                                                                                                                       **/
/**********************************************************************************************************************************/
int	verbose;
int	con_lambda;
int	extend;
float	cell[6];
int 	iuvw[3];
float 	refl[MAX_NOF_REFL][7];
int	spacegroup;
int	transform;
int	PATTERSON;
int	HAVE_FOM;
float	SQRT_SIGMA;
float	LIMIT_SIGMA;
float	AVER_SIGMA;
float	SCALE_FOM;
float	MAX_FOM;
float	MIN_FOM;
float	TARGET_CHI;
int	ORIGIN_REMOVED;
int	MAP_FORMAT;
int	GRAPH_INTER;
int	GRAPH_WAIT;
int	GRAPH_SECTION;
int	DO_PLOT;
int	GRAYSCALE;
int	KEEPCONV;
float	chicontrib[MAX_NOF_REFL];
int	chirefl[MAX_NOF_REFL][3];
int	chitable;
int	chipointers[MAX_NOF_REFL][3];
int	WILL_TEST;
int	DIFF_PATTERSON;
int	MTZ_HAVE_RES = NO;
int	HAVE_ZONE_SELECTION = NO;
double  normtab[2][4096];
int	DO_REJECT;
int	HAVE_F000 = NO;
int	SHOW_ENTROPY = NO;
int	VERB_INTERVAL = 50;
int	HAVE_TIME = NO;
float	CONTOUR_LEVEL = 0.5000;
float	FIRST_CONTOUR = 0.0000;
float	max_res;
int	MAKE_NONUNIFORM = NO;
float	PEAK_BACKGROUND = -1.0;
int	PHASELESS = NO;
float	FOM_PHASELESS;
float	SWITCH = -1.0;
int	total_number_of_obs;
float	excl_fom = -1.0;
int	MAKE_PS = NO;






/**********************************************************************************************************************************/
/**  Supported map types                                                                                                         **/
/**********************************************************************************************************************************/

#define		CCP4_MAP	1
#define		NA4_MAP		2
#define		ASCII_MAP	3











/**********************************************************************************************************************************/
/**  Two-level control (so that we can switch them off even if we do have them at compilation time                               **/
/**********************************************************************************************************************************/


#ifdef NOCCP4
int 	HAVE_CCP4 = NO;
#else
int	HAVE_CCP4 = YES;
#endif



#ifdef NOPGPLOT
int 	HAVE_PGPLOT = NO;
#else
#include "cpgplot.h"
int 	HAVE_PGPLOT = YES;
#endif




















main(argc, argv)
int     argc;
char    *argv[];
{

	/* Map handling */
	int 	test_file;
	int	ier;


	/* For FFT */
	float	***Fobs_1;    
	float	***SigF_1;    
	float	***PriorA_1;    
	FILE	*wisdom;


	/* Rest */   
	int	grid_x, grid_y, grid_z, size;
	int	i, m, n;
	int	thrown;
	double	ini_lambda;
	int	u, v, w;
	float	sum_dens, sum_sq;
	float	max, min, inte;
	float	val;
	float	scale;
	float	norm;
	float	R_factor;
	int	obs;
	float	average_F;
	float	amp, estimated_sigma, sig;
	FILE	*in;
	FILE 	*out;
	char	string[80];
	char	*name[80];
	float	Fo, Fc;	
	float	h, k, l, F, sigF, phi, fom;
	float	A, B;
	int	added_refl;
	float	search1, search2;
	time_t	t1, t2;	
	time_t  tjunk;
	float	rec_a, rec_b, rec_angle;
	float	length;
	float	psigA, psigB;
	char	jchar[80];
	char	envi[300]="SYMOP=";
	float	mean, rms, chi_limit;
	int	chi_above;
	char	line[ 300];
	float	q1, q2, q3, q4, q5, q6, q7, q8, q9;
	int	items;
	int	hmin,hmax,kmin,kmax,lmin,lmax;
	int	ht, kt, lt;
	int	hgrid, kgrid, lgrid;
	float	fph, sigfph;
	float	exclusion_limit;
	float	RES_LOW, RES_HIGH;
	char	zone[5];
	char	wisdom_name[300];
	int	brejected[3][MAX_REJ];
	FILE	*rej;
	int	nof_rej;
	int	SKIP;
	float	GLOBAL_SCALE = -1.0;	
	int	nof_unknown;
	int	c;
	char	details[81];
	char	junk[300];
	int	abs_hmax, abs_kmax, abs_lmax;
	int	phasenot = 0;
	float	mem_req;
	int	excluded_due_to_fom;
	
	
	



#ifndef VMS        
	signal( SIGFPE, SIG_IGN );	/* Hmmm */
        setlinebuf( stdout ); 		/* Some people can't wait to see the next line in the LOG file */       
#endif	




	t1 = time(0);
	printf("\n\n\n\n\n\n\n\n");


	printf("___________________________________________________________________________________________________________________________\n");
	printf("                                                                                    \n");
	printf("                              ###   ###                   #######            #      \n");
	printf("                               ##   ##                     #    #            #      \n");
	printf("                               # # # #   ####   ### ###    #    # ## ###   ######   \n");
	printf("                               # # # #  #    #   #   #     #  #    ##   #    #      \n");
	printf("                               #  #  #       #    # #      ####    #    #    #      \n");
	printf("                               #  #  #   #####     #       #  #    #    #    #      \n");
	printf("                               #     #  #    #    # #      #    #  #    #    #      \n");
	printf("                               #     #  #    #   #   #     #    #  #    #    #   #  \n");
	printf("                              ###   ###  #### # ### ###   ####### ###  ###    ###   \n");
	printf("                                                                                            \n");
	printf("                            Gull, S.F. & Daniell, G.J. (1978), Nature, 272, 686-690         \n");
	printf("                                   Collins, D.M. (1982), Nature, 298, 49-51                 \n");
	printf("                                                                                            \n");
	printf("                                                      NMG                                   \n");
	printf("                                                                                                \n");
	printf("___________________________________________________________________________________________________________________________\n\n");










	/*********************************************************************************************************************************/
	/**  If we have CCP4, create an enviromental variable SYMOP pointing to the symmetry operators file 				**/
	/*********************************************************************************************************************************/
								

	if ( HAVE_CCP4 == YES )
		{
			if ( getenv("CLIBD") == NULL )
				{
					printf("CCP4 symbol missing : CLIBD not defined. No support for CCP4.\n");
					HAVE_CCP4 = NO;
							}
			else
			{	
			strcat( envi, getenv("CLIBD") );
			strcat( envi, "/symop.lib");
			putenv( envi );
				}
						}






				
	/*********************************************************************************************************************************/
	/**  In the case of a CCP4 run we may have zone definition and resolution limits (both required). 				**/
	/*********************************************************************************************************************************/


	if  ( HAVE_CCP4 == YES && ( argc == 3 || argc == 5 ))		/* We may have a zone definition.  */
		{
			if ( 	strcasecmp( argv[1], "HK0" ) == 0  ||
				strcasecmp( argv[1], "0KL" ) == 0  ||
				strcasecmp( argv[1], "H0L" ) == 0 )
				{
					HAVE_ZONE_SELECTION = YES;
					strcpy( zone, argv[1] );
					if ( argc == 3 )
						{
							strcpy( argv[1], argv[2] );
							argc = 2;
								}
					else
						{
							strcpy( argv[1], argv[2] );
							strcpy( argv[2], argv[3] );
							strcpy( argv[3], argv[4] );
							argc = 4;
								}
						
				
					}
			else
				abortp();	
				
			
		}







	/*********************************************************************************************************************************/
	/**  If no argument is given, try to open a MAXENT.DAT file from the current directory						**/
	/*********************************************************************************************************************************/

	if ( argc == 1 )
		{
			test_file = open( "MAXENT.DAT", O_RDONLY, 0 );
			if ( test_file == -1 )
				abortp();
			close( test_file );
								}
	else
		if ( argc > 5 )
			abortp();
		
	else
	/*********************************************************************************************************************************/
	/**  Resolution limits for .mtz run												**/
	/*********************************************************************************************************************************/

		if ( argc == 4 )
			{
			if ( HAVE_CCP4 == YES && strncasecmp( &argv[3][strlen(argv[3])-4], ".MTZ", 4 ) == 0 )
			{
			if ( sscanf( argv[1], "%f", &RES_LOW ) == 1 && sscanf( argv[2], "%f", &RES_HIGH ) == 1 )
				{
					if ( RES_LOW < RES_HIGH )
						{
							val = RES_HIGH;
							RES_HIGH = RES_LOW;
							RES_LOW = val;
								}
					MTZ_HAVE_RES = YES;
					argc = 2;
					strcpy( argv[1], argv[3] );
									}
			else
				abortp();
			}
			else
				abortp();
			}
	else
		{
			test_file = open( argv[1], O_RDONLY, 0 );			
			if ( test_file == -1 )
				{
					printf("Can not open %s\n", argv[1]);
					abortp();
							}
			close( test_file );
								}
	







	/**************************************************************************************************************************/
	/**   If we have CCP4 and the file name ends in .mtz, start interpreting mtz file                                        **/
	/**************************************************************************************************************************/
#ifndef NOCCP4
	if ( argc == 2 && HAVE_CCP4 == YES && strncasecmp( &argv[1][strlen(argv[1])-4], ".MTZ", 4 ) == 0 )
	{
        int     mindx;
        int     iprint;
        int     ifail;
        float   resol;
        float   adata[40];
        int     eof;
        int     i;
	int	ncolx;
	int	missing[40];
	char	clabs[40][30];
	char	ctyps[40][1];
	int	more_col;
	char	all[20];
	int	type;
	char	type_d[300];
	FILE	*out2, *out3;


	printf(" - Assuming that input is a .mtz file. Interpreting ...\n\n");






	/*********************************************************************************************************************************/
	/**  MTZ stuff. Open mtz file, get column types and start comparing with supported modes of operation				**/
	/*********************************************************************************************************************************/
        mindx = 1;
        iprint = 1;
        mtzini_();
        lropen_( &mindx, &argv[1][0],  &iprint, &ifail, strlen(argv[1]) );

	if ( ifail == -1 )
		{
			printf("\n\nMTZ error (lropen()). Abort.\n\n");
			exit(1);
					}
	lrcell_( &mindx, &cell[0] );
	lrncol_( &mindx, &ncolx );
	if ( ncolx > 28 )
		{
			printf("\n\nToo many columns in .mtz. Abort.\n\n");
			exit(1);
					}
	more_col = 30;
	lrclab_( &mindx, &clabs[0][0], &ctyps[0][0], &more_col );
	for ( i=0 ; i < more_col ; i++ )
		all[i] = ctyps[i][0];
	
	all[i] = 0;



	/* What we think we know what to do about */

	if ( strncmp(all,"HHHFQPW",7   ) == 0 )
		{
			type = 2;
			strcpy( type_d, "Synthesis with h,k,l,F,sig(F),phi and known FOMs");
				}
	else if ( strncmp(all,"HHHFQP",6) == 0 )
		{
			type = 1;
			strcpy( type_d, "Synthesis with h,k,l,F,sig(F),phi but without FOMs");
				}
	else if ( strncmp(all,"HHHFQFQDQ",9 ) == 0 )
		{
			type = 4;
			strcpy( type_d, "Isomorphous difference Patterson synthesis with h,k,l,FP,sig(FP),FPH,sig(FPH) (anomalous data present)");
				}
	else if ( strncmp(all,"HHHFQFQ",7   ) == 0 )
		{
			type = 3;
			strcpy( type_d, "Isomorphous difference Patterson synthesis with h,k,l,FP,sig(FP),FPH,sig(FPH)");
				}
	else if ( strncmp(all,"HHHDQ" ,5    ) == 0 )
		{
			type = 5;
			strcpy( type_d, "Anomalous Patterson function with h,k,l,Danom,sig(Danom)");
				}
	else if ( strncmp(all,"HHHFQ", 5     ) == 0 )
		{
			type = 6;
			strcpy( type_d, "Patterson function calculation with h,k,l,F,sig(F)");
				}
	else
		type = 0;






	if ( type != 0 )
	{

	/*********************************************************************************************************************************/
	/**  Found a recognisable column type combination. 										**/
	/*********************************************************************************************************************************/
	lrclos_(&mindx);
	printf(" - Accepted column type combination found.\n");
	







	/*********************************************************************************************************************************/
	/**  If we have a zone selection, run mtzutils on the input file								**/
	/*********************************************************************************************************************************/
	if ( HAVE_ZONE_SELECTION == YES )
	{

	printf(" - Zone selection with MTZUTILS.\n");

	/* This will definetely not work with VMS */

	out = fopen( "MAXENT_script_for_mtzutils.in", "w" );
	fprintf( out, "\n\nmtzutils hklin %s hklout MAXENT_zone.mtz > MAXENT_MTZUTILS_RUN.LOG << eof\n", argv[1]);
	fprintf( out, "ONEFILE\n");
	fprintf( out, "INCLUDE ALL\n");
	fprintf( out, "AXIS %s\n", zone);
	fprintf( out, "RUN\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("chmod 755 MAXENT_script_for_mtzutils.in ; ./MAXENT_script_for_mtzutils.in");





	/*********************************************************************************************************************************/
	/**  There must be better ways to confirm that everything went OK with mtzutils 						**/
	/*********************************************************************************************************************************/
	test_file = open( "MAXENT_zone.mtz", O_RDONLY, 0 );
	if ( test_file == -1 )
		{
			printf("\n\nMTZUTILS failure ? Is CCP4 up and running ?\n\n");
			exit(1);
					}
	close( test_file );
	}
	





	/*********************************************************************************************************************************/
	/**  Now, its CAD's turn to expand the data to P1										**/
	/*********************************************************************************************************************************/

	printf(" - Proceed to data expansion with CAD.\n");

	out = fopen( "MAXENT_script_for_cad.in", "w" );
	if ( HAVE_ZONE_SELECTION == NO )
	fprintf( out, "\n\ncad hklin1 %s hklout FOR_MAXENT_P1.mtz > MAXENT_CAD_RUN.LOG << eof\n", argv[1]);
	else
	fprintf( out, "\n\ncad hklin1 MAXENT_zone.mtz hklout FOR_MAXENT_P1.mtz > MAXENT_CAD_RUN.LOG << eof\n");
	
	fprintf( out, "OUTLIM SPACEGROUP 1\n");
	fprintf( out, "LABIN FILE 1 ALL\n");
	fprintf( out, "END\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("chmod 755 MAXENT_script_for_cad.in ; ./MAXENT_script_for_cad.in");

	/* Hmm ... */
	test_file = open( "FOR_MAXENT_P1.mtz", O_RDONLY, 0 );
	if ( test_file == -1 )
		{
			printf("\n\nCAD failure ? Is CCP4 up and running ?\n\n");
			exit(1);
					}
	close( test_file );
	





	/*********************************************************************************************************************************/
	/** In the final step, open .mtz file from CAD and prepare an AUTO labelled file with cell and reflections. 		 	**/
	/** The created MAXENT_FROM_MTZ.in will be further interpreted (as all AUTO-labelled files do).					**/ 
	/*********************************************************************************************************************************/
	
	printf(" - Final .mtz pass : preparing ascii file for MAXENT.\n");
	printf("   Synthesis type set to :\n   %s\n", type_d );
        out = fopen( "MAXENT_FROM_MTZ.in", "w");
	fprintf( out, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  1\n", 
			cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );
	







	/*********************************************************************************************************************************/
	/**  Type 4 is isomomorphous difference Patterson function which includes anomalous data. Will create two additional files.	**/
	/**  The MAXENT_FROM_MTZ_ANOMALOUS.in contains DFano, whereas MAXENT_SUM_PATT.in contains sqrt(DFiso^2 + DFano^2) coefficients  **/
	/*********************************************************************************************************************************/
	if ( type == 4 )
		{
		        out2 = fopen( "MAXENT_FROM_MTZ_ANOMALOUS.in", "w");
			fprintf( out2, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  1\n", 
					cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );

		        out3 = fopen( "MAXENT_SUM_PATT.in", "w");
			fprintf( out3, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  1\n", 
					cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );
				}
	




	/*********************************************************************************************************************************/
	/**  Open mtz file and start reading reflection records 									**/
	/*********************************************************************************************************************************/
	mindx = 1;
        iprint = 1;
        mtzini_();
        lropen_( &mindx, "FOR_MAXENT_P1.mtz",  &iprint, &ifail, 17 );
	if ( ifail == -1 )
		{
			printf("\n\nMTZ error (lropen()) ? Abort.\n\n");
			exit(1);
					}
	

	lrrefl_(&mindx, &resol, &adata[0], &eof );
	lrrefm_(&mindx, &missing[0]);

	while( eof != 1 )
	{
	if ( MTZ_HAVE_RES == NO || (MTZ_HAVE_RES == YES && sqrt(1.0/resol) >= RES_HIGH && sqrt(1.0/resol) <= RES_LOW))
	{


	/*********************************************************************************************************************************/
	/**  Depending on the type of synthesis, export correct number and type of columns to the AUTO labelled file 			**/
	/*********************************************************************************************************************************/

	if ( type == 1 )
	{		
		if ( !(missing[3] | missing[4] | missing[5] ) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 10.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5] );
	}
	else if ( type == 2 )
	{		
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 10.5f % 10.7f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );
	}
	else if ( type == 3 )
	{									/* Some  people's .mtz dont't have MNFs */
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) 
		&& !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );
	}
	else if ( type == 4 )
	{									/* Some people's .mtz dont't have MNFs */
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) 
		&& !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)) )
		fprintf( out,  "% 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), 
					nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );


							/* This is awful. I should be using symlib to check if the reflection is centric */

		if ( !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) )
		fprintf( out2, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), 
											fabs(adata[7]), adata[8] );
		
		

		/* This is for a "sum difference Patterson" (an approximation to FHLE). We explicitly square, and set phases to 0 */
		/* Note that for this calculation we need Kemp. Assume that 4 anomalous electrons is a reasonable number and cont. */
		/* Have both DFiso and DANO */
		if (
			!(missing[3] | missing[4] | missing[5] | missing[6] )
		     && !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010))
		     && !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) )
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[3]-adata[5])*(adata[3]-adata[5]) + (adata[7]*adata[7]),
					sqrt( 4.0*(adata[3]-adata[5])*(adata[3]-adata[5])*(adata[4]*adata[4]+adata[6]*adata[6]) +
					16.0*adata[7]*adata[7]*adata[8]*adata[8] ));
		else
		/* Only DFiso */
		if (
			!(missing[3] | missing[4] | missing[5] | missing[6] )
		     && !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)))
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[3]-adata[5])*(adata[3]-adata[5]) ,
					sqrt( 4.0*(adata[3]-adata[5])*(adata[3]-adata[5])*(adata[4]*adata[4]+adata[6]*adata[6]) ));
		else
		/* Only DFano */
		if ( !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) ) 
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[7]*adata[7]), sqrt(16.0*adata[7]*adata[7]*adata[8]*adata[8] ));
		
		
		
		
	}
	else if ( type == 5 )						
	{					
		if ( !(missing[3] | missing[4] ) && !( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4] );
	}
	else if ( type == 6 )
	{		
		if ( !(missing[3] | missing[4] ) && !( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4] );
	}		
	}
	lrrefl_(&mindx, &resol, &adata[0], &eof );	
	lrrefm_(&mindx, &missing[0]);
	}
	
	fclose(out);
	if ( type == 4 )
		{
		fclose( out2 );
		fclose( out3 );
		}
	lrclos_(&mindx);		


	/*********************************************************************************************************************************/
	/**  For the rest of the program it would appear that you started the calculation with this ASCII (AUTO-labelled file)		**/
	/*********************************************************************************************************************************/
	strcpy( argv[1], "MAXENT_FROM_MTZ.in" );


	}
	else
	{

	/*********************************************************************************************************************************/
	/**  Column type combination not recognised.											**/
	/*********************************************************************************************************************************/

	printf("\n\nFailed to guess intended map type from column types. Use CAD to select only relevant columns.\n\n");
	exit( 1 );
	}

	/* Hoping that `rm' still means rm */ 
	system("rm -rf ./MAXENT_script_for_mtzutils.in");
	system("rm -rf ./FOR_MAXENT_P1.mtz");
	system("rm -rf ./MAXENT_CAD_RUN.LOG");
	system("rm -rf ./MAXENT_MTZUTILS_RUN.LOG");
	system("rm -rf ./MAXENT_zone.mtz");
	system("rm -rf ./MAXENT_script_for_cad.in");

	
	printf("___________________________________________________________________________________________________________________________\n\n");
	
	}
#endif	








	/**************************************************************************************************************************/
	/**   If the first string on the first line is AUTO, start creating an input file                                        **/
	/**************************************************************************************************************************/
	if ( argc == 1 )
		in = fopen("MAXENT.DAT", "r" );
	else
		in = fopen(argv[1], "r" ); 
	if ( in == NULL )
		{
			printf("\n\nCan not open input file. Abort.\n\n");
			exit(1);
		}
	
	if ( fscanf( in, "%s", &string[0] ) == EOF )
		{
			printf("\n\nEmpty input file ? Abort.\n\n\n");
			exit(1);
					}
	
	

	if ( strncasecmp( &string[0], "AUTO", 4) == 0 )
	{

	/* Well, you never know */
	if ( strcasecmp( &argv[1][0], "MAXENT_AUTO.IN" ) == 0 )
		{
			printf("\n\nPlease give your input file a different name (MAXENT_AUTO.IN will be opened for writing).\n");
			exit(1);
				}
	
	
	
	HAVE_FOM = NO;
	printf(" - AUTO keyword present. Interpreting input ...\n");
	
	if ( fscanf( in, "%f %f %f %f %f %f %d", &cell[0], &cell[1], &cell[2], &cell[3], &cell[4], &cell[5], &spacegroup ) != 7 )
		{
			printf("\n\nError. Expected format is 'AUTO a b c alpha beta gamma spacegroup_number'\n\n");
			exit( 1 );
					}
	rewind( in );
	fgets( line, 299, in );
	fgets( line, 299, in );


	/* This is not a safe way to count columns in a line */
	items = sscanf( line, "%f %f %f %f %f %f %f %f",&q1,&q2,&q3,&q4,&q5,&q6,&q7,&q8 );
	
	if ( items >= 8 )
		{
			printf("\n\nToo many (>=8) entries for each reflection record. Abort.\n\n");
			exit( 1 );
					}
	if ( items < 5 )
		{
			printf("\n\nToo few (<=4) entries for each reflection record. Abort.\n\n");
			exit( 1 );
					}
			


	/*********************************************************************************************************************************/
	/**  Start preparing final input file (MAXENT_AUTO.IN)										**/
	/*********************************************************************************************************************************/
	out = fopen("MAXENT_AUTO.IN", "w");
	fprintf( out, "# \n");
	fprintf( out, "# \n");
	fprintf( out, "# Automatically produced by GraphEnt\n");
	fprintf( out, "# \n");
	fprintf( out, "# \n\n");
	



	fprintf( out, "#\n# Cell and space group number\n#\n");
	fprintf( out, "CELL              %7.3f  % 7.3f  % 7.3f  % 7.3f  % 7.3f  % 7.3f\n", 
			cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );
	fprintf( out, "SPACEGROUP        %d\n", spacegroup );


	fprintf( out, "\n#\n# Output map format\n#\n");
	if ( HAVE_CCP4 == YES )
		fprintf( out, "MAP_FORMAT        CCP4\n");
	else
		fprintf( out, "MAP_FORMAT        ASCII\n");
		
		
	if ( items == 5 )
		{
			printf(" - Five items found. Assuming these are h,k,l,F,sig(F) for a Patterson calculation.\n");
			fprintf( out, "\n#\n# Patterson calculation assumed. Exclude small differences.\n#\n");
			fprintf(out, "PATTERSON\n");
			fprintf(out, "LIMIT             0.50\n");
				}
	if ( items == 6 )
		printf(" - Six items found. Assuming these are h,k,l,F,sig(F) and phi.\n");
	if ( items == 7 )
	{
	while ( fgets( line, 299, in ) != NULL )   			
		{
			if ( sscanf( line, "%f %f %f %f %f %f %f",&q1,&q2,&q3,&q4,&q5,&q6,&q7 ) != 7 )
				{
					printf("\n\nProblem with a reflection record : can not read seven items.\n\n");
					exit(1);
							}
			if ( q7 > 1.010 )
				break;
								}
	if ( q7 > 1.0 )
		{
			printf(" - Seven items found and the last is not FOM. h,k,l,FP,sig(FP),FPH,sig(FPH) for difference Patterson assumed.\n");
			fprintf( out, "\n#\n# Difference Patterson calculation assumed. Exclude small differences.\n#\n");
			fprintf(out, "DIFF_PATT\n");
			fprintf(out, "LIMIT             0.50\n");
				}
	else
		{
			printf(" - Seven items found and the last is FOM. Synthesis with h,k,l,F,sig(F),phi,FOM assumed.\n");
			fprintf( out, "\n#\n# Phased synthesis with FOM present.\n#\n");
			fprintf(out, "FOM_PRESENT\n");					
			HAVE_FOM = YES;
				}
	}
	
	
	rewind(in);
	fgets( line, 299, in );



	/*********************************************************************************************************************************/
	/**  Indeces range for grid size estimation											**/
	/*********************************************************************************************************************************/

	printf(" - First pass to determine indeces ranges.\n");
	hmin =  10000;
	hmax = -10000;
	kmin =  10000;
	kmax = -10000;
	lmin =  10000;
	lmax = -10000;
	while ( fgets( line, 299, in ) != NULL )
		if ( sscanf( line, "%d %d %d", &ht, &kt, &lt ) != 3 )
			{
				printf("\n\nProblem with reflection record : can not read indeces.\n\n");
				exit(1);
						}
		else
			{
				if ( ht > hmax )
					hmax = ht;
				else
					if ( ht < hmin  )	
						hmin  = ht;

				if ( kt > kmax )
					kmax = kt;
				else
					if ( kt < kmin  )	
						kmin  = kt;

				if ( lt > lmax )
					lmax = lt;
				else
					if ( lt < lmin  )	
						lmin  = lt;
								}


	/*********************************************************************************************************************************/
	/**  get_grid() returns a good FFT number close to the given argument							 	**/
	/*********************************************************************************************************************************/

	if ( hmin != 0 || hmax != 0 )
		hgrid = get_grid( GRID_FINE * max2( fabs(hmin), fabs(hmax) ));
	else
		hgrid = 1;

	if ( kmin != 0 || kmax != 0 )
		kgrid = get_grid( GRID_FINE * max2( fabs(kmin), fabs(kmax) ));
	else
		kgrid = 1;

	if ( lmin != 0 || lmax != 0 )
		lgrid = get_grid( GRID_FINE * max2( fabs(lmin), fabs(lmax) ));
	else
		lgrid = 1;


	/*********************************************************************************************************************************/
	/**  Few additional checks													**/
	/*********************************************************************************************************************************/
		
	if ( ( hgrid == 1 && kgrid == 1 ) ||
	     ( hgrid == 1 && lgrid == 1 ) ||
	     ( kgrid == 1 && lgrid == 1 ) )
		{
			printf("\n\nCan not do one-dimensional syntheses.\n\n");
			exit( 1 );
					}
	


	/*********************************************************************************************************************************/
	/** Permutation selection. I bet that some of these change chirality. The point is that with 3D data in the correct hemisphere	**/
	/** the permutation will always be 312 (which I have repeatedly checked that gives the correct hand)				**/
	/*********************************************************************************************************************************/


	fprintf( out, "\n#\n# Axes permutation and grid spacing.\n#\n");
	if ( hgrid > 1 && kgrid > 1 && lgrid > 1 )
		{
			fprintf(out, "PERMUTATION       3 1 2\n");
			fprintf(out, "GRID              %d % 6d % 6d\n", lgrid, hgrid, kgrid);
				}
	else
		if ( hgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	3 2 1\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", lgrid, kgrid, hgrid);
				}
	else
		if ( kgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	3 1 2\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", lgrid, hgrid, kgrid);
				}
	else
		if ( lgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	1 2 3\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", hgrid, kgrid, lgrid);
				}
	else
		{
			printf("\n\nGRID selection failure. This shouldn't have happened. PANIC.\n\n");
			exit( 1 );
					}
					
	if ( HAVE_PGPLOT == YES )
		{
			fprintf( out, "\n#\n# Graphics support and options.\n#\n");
			fprintf( out, "PSOUT\n");
			fprintf( out, "GRACYCLES    	%d\n", (int)(2621440 / (2 * hgrid * kgrid * lgrid)) > 1 ? 
					(int)(2621440 / (2 * hgrid * kgrid * lgrid)) : 2 );
			fprintf( out, "GRATWOWINDOWS\n");
				}
	

	/* Too much ? */
	/* 
	fprintf( out, "VERBOSE\n");
	*/	




	/*********************************************************************************************************************************/
	/**  Finally, write out reflection records											**/
	/*********************************************************************************************************************************/
	printf(" - Second (final) pass for output.\n");
	rewind(in);
	fgets( line, 299, in );
	obs = 0;
	fprintf( out, "\n#\n# Reflection records follow\n#\n");
	fprintf( out, "REFLECTIONS\n");
	if ( items == 5 )
		{
		while ( fscanf( in, "%d %d %d %f %f", &ht, &kt, &lt, &q1, &q2) == 5 )
			{
			fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f\n", ht, kt, lt, q1, q2 );
			obs++;
			}
		}
	else
		if ( items == 6 )
			{
			while ( fscanf( in, "%d %d %d %f %f %f", &ht, &kt, &lt, &q1, &q2, &q3) == 6 )
				{
				fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f\n", ht, kt, lt, q1, q2, q3 );
				obs++;
				}
			}
	else
		if ( items == 7 )
			{
			while ( fscanf( in, "%d %d %d %f %f %f %f", &ht, &kt, &lt, &q1, &q2, &q3, &q4) == 7 )
				{
				fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", ht, kt, lt, q1, q2, q3, q4 );
				obs++;
				}
			}
	else
		{
			printf("\n\nNumber of items outside range. This shouldn't have happened. PANIC.\n\n");
			exit( 1 );
					}
	printf(" - %d reflections matched and output.\n", obs );
	
	



	/**************************************************************************************************************************/
	/**   If two pairs of measurements, and have graphics, do a normal probability plot                                      **/
	/**************************************************************************************************************************/
	if ( items == 7 && HAVE_FOM == NO && HAVE_PGPLOT == YES )
		normprob( in );
		
	
	
	
	printf("___________________________________________________________________________________________________________________________\n\n");
	fclose( in );
	fclose(out);		
	
	argc = 2;
	argv[1] = "MAXENT_AUTO.IN";
	
	}
	else
		fclose(in);
		
						




	/*********************************************************************************************************************************/
	/**  All processing of mtz and AUTO labelled is finished. We now have a keyworded input file to work with 			**/
	/*********************************************************************************************************************************/
	/**************************************************************************************************************************/
	/**   Now we are ready for business as usual 		                                                                 **/
	/**************************************************************************************************************************/



	ini_lambda = -1.0;
	verbose    = NO;
	con_lambda = NO;
	extend 	   = NO;
	grid_x	   = 0;
	iuvw[0]    = -1;
	cell[0]	   = 0.0;
	spacegroup = 0;
	verbose    = NO;
	extend     = NO;
	transform  = NO;
	PATTERSON  = NO;
	HAVE_FOM   = NO;
	SQRT_SIGMA = -1.0;
	AVER_SIGMA = -1.0;
	SCALE_FOM  = -1.0;
	MAX_FOM    = -1.0;
	MIN_FOM    = -1.0;
	TARGET_CHI = -1.0;
	ORIGIN_REMOVED 	= NO;
	GRAPH_INTER	= 10;
	GRAPH_SECTION 	= 1;
	GRAPH_WAIT	= NO;
	DO_PLOT	   	= NO;	
	GRAYSCALE 	= NO;
	KEEPCONV 	= NO;
	chi_limit	= 10.0;
	WILL_TEST 	= NO;
	DIFF_PATTERSON  = NO;
	exclusion_limit = -1.0;
	DO_REJECT = NO;
	LIMIT_SIGMA 	= -1.0;
	excl_fom 	= -1.0;
	
	
	
	if ( HAVE_CCP4 == YES )
		MAP_FORMAT = CCP4_MAP;
	else
		MAP_FORMAT = ASCII_MAP;
		
	
	if ( argc == 1 )
		in = fopen("MAXENT.DAT", "r" );
	else
		in = fopen(argv[1], "r" ); 
	
	if ( in == NULL )
		{
			printf("\n\nCan not open input file. Abort.\n\n");
			exit(1);
		}


	/* You never know */
	for ( i=0 ; i < 200 ; i++ )
		if ( ( c = getc( in )) == EOF || isascii(c) == 0 )
			break;
	
	rewind(in);
	if ( i != 200 && c != EOF )
		printf("\n\nThe input file must be a formatted (ASCII) file, but non-ASCII characters are present. Beware.\n\n");
							
	

	
	/*********************************************************************************************************************************/
	/** This is one of the worst ways to read input (string-wise instead on line-wise)					 	**/
	/*********************************************************************************************************************************/
	/*********************************************************************************************************************************/
	/**  KEYWORDS AND FLAGS AND PARAMETERS 												**/
	/*********************************************************************************************************************************/
	nof_unknown = 0;
	while ( fscanf( in, "%s", &string[0] ) != EOF )
		{
			for ( i=0 ; i < 4 ; i++ )
				string[i] = toupper( string[i] );
				
			if ( strncasecmp( &string[0], "GRID", 4) == 0 )
				{
				if ( fscanf( in, "%d %d %d", &grid_y, &grid_x, &grid_z ) != 3 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}
				else
				printf("Keyword % 16s : Grid set to % 5d % 5d % 5d\n", &string[0], grid_y, grid_x, grid_z );
					}
			else
			if ( strncasecmp( &string[0], "CELL", 4) == 0 )
				{ if ( fscanf( in, "%f %f %f %f %f %f", &cell[0], &cell[1], &cell[2], &cell[3], &cell[4], &cell[5] ) != 6 )
					{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : Cell dimensions set to %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f\n", 
					&string[0], cell[0], cell[1], cell[2], cell[3], cell[4], cell[5]  );
				}
			else
			if ( strncasecmp( &string[0], "PERM", 4) == 0 )
				{
				if ( fscanf( in, "%d %d %d", &iuvw[0], &iuvw[1], &iuvw[2] ) != 3 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}			
				else
				printf("Keyword % 16s : Permutation set to %d %d %d\n", &string[0], 
						iuvw[0], iuvw[1], iuvw[2] );
				}
			else
			if ( strncasecmp( &string[0], "PHAS", 4) == 0 )
				{
				if ( fscanf( in, "%f", &FOM_PHASELESS ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}			
				else
				{
				PHASELESS = YES;
				printf("Keyword % 16s : Reflections with FOM less than %5.3f will be treated as phase-less.\n", 
									&string[0], FOM_PHASELESS );
				}
				}

			else
			if ( strncasecmp( &string[0], "EXFO", 4) == 0 )
				{
				if ( fscanf( in, "%f", &excl_fom ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}			
				else
				printf("Keyword % 16s : Reflections with FOM less than %5.3f will be rejected.\n", 
									&string[0], excl_fom );
				}

			else
			if ( strncasecmp( &string[0], "SWIT", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SWITCH ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}			
				else
				{
				if ( SWITCH >= 1.0 || SWITCH <= 0.0 )
					SWITCH = -1.0;
				else
				{
				printf("Keyword % 16s : After reaching an R-factor=%4.2f the calculation will proceed in phase-less mode.\n", 
									&string[0], SWITCH );
				}
				}
				}

			else
			if ( strncasecmp( &string[0], "VERB", 4) == 0 )
				{
					verbose = YES;
					printf("Keyword % 16s : verbose mode set.\n", &string[0]);
						}
			else
			if ( strncasecmp( &string[0], "SHOW", 4) == 0 )
				{
					SHOW_ENTROPY = YES;
					printf("Keyword % 16s : entropy value will be calculated.\n", &string[0]);
						}
			else
			if ( strncasecmp( &string[0], "REJE", 4) == 0 )
				{
				
				
					/* If REJECT specified, open REJECT.HKL and read and store relection indeces for later use */
				
					DO_REJECT = YES;
					rej = fopen( "REJECT.HKL", "r");
					if ( rej == NULL )
						{
						printf("Keyword REJEect specified, but file REJECT.HKL can not be opened.\n");
						DO_REJECT = NO;
						}
					else
					{
					nof_rej = 0;
					while( fgets( line, 299, rej ) != NULL )
					{
					if ( sscanf( line, "%d %d %d", &brejected[0][nof_rej], &brejected[1][nof_rej], &brejected[2][nof_rej]) == 3 )
						nof_rej++;
					else
						printf("Problem with reflection record in REJECT.HKL.\n");
							
					}	
					fclose(rej);				
					printf("Keyword % 16s : %d reflections specified in REJECT.HKL.\n", &string[0], nof_rej );
					}
						}
			else		
			if ( strncasecmp( &string[0], "REMO", 4) == 0 )
				{
				ORIGIN_REMOVED = YES;
				printf("Keyword % 16s : Origin-removed Patterson function.\n", &string[0]);
				}
			else
			if ( strncasecmp( &string[0], "PRIO", 4) == 0 )
				{
				MAKE_NONUNIFORM = YES;
				if ( fscanf( in, "%f", &PEAK_BACKGROUND ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : Non-uniform prior for Patterson function. Peak/background ratio set.\n", &string[0]);
				
				if ( PEAK_BACKGROUND >= 0.990 || PEAK_BACKGROUND < 0.0 )
					PEAK_BACKGROUND = -1.0;
				}
			else
			if ( strncasecmp( &string[0], "SQRT", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SQRT_SIGMA ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : sigma(F)=%4.2f*SQRT(F).\n", &string[0], SQRT_SIGMA);
				}

			else
			if ( strncasecmp( &string[0], "GRAL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &CONTOUR_LEVEL ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}
				else
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );				
				else
				{
				if ( CONTOUR_LEVEL < 0.0010 || CONTOUR_LEVEL > 1000.0 )
					{
						printf("Argument of GRALevel (%f) outside range. Set to 0.50.\n", CONTOUR_LEVEL);
						CONTOUR_LEVEL = 0.5000;
									}
				else
					printf("Keyword % 16s : contouring interval set to %f rmsd.\n", &string[0], CONTOUR_LEVEL);
				}
				}

			else
			if ( strncasecmp( &string[0], "GRAF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &FIRST_CONTOUR ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}
				else				
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				if ( FIRST_CONTOUR < -100.000 || FIRST_CONTOUR > 100.0 )
					{
						printf("Argument of GRAFirst (%f) outside range. Set to 0.00\n", FIRST_CONTOUR);
						FIRST_CONTOUR = 0.00000;
									}
				else
					printf("Keyword % 16s : first contour at mean + %f rmsd.\n", &string[0], FIRST_CONTOUR);
				}
				}

			else
			if ( strncasecmp( &string[0], "LIMI", 4) == 0 )
				{
				if ( fscanf( in, "%f", &LIMIT_SIGMA ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : exclude reflections with |F|/sig(|F|)<%f.\n", &string[0], LIMIT_SIGMA);
				}
			else
			if ( strncasecmp( &string[0], "TIME", 4) == 0 )
				{
				if ( fscanf( in, "%d", &HAVE_TIME ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				{
				if ( HAVE_TIME < 0 )
					{
						HAVE_TIME = 0;
						printf("Malformed keyword (%s).\n", &string[0] );
						}
				else
				{
				printf("Keyword % 16s : time-out limit set to %d minutes.\n", &string[0], HAVE_TIME);
				HAVE_TIME *= 60;
				}
				}
				}
			else
			if ( strncasecmp( &string[0], "CHIL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &chi_limit ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : limit for monitoring reflection contribution to chi^2 is set to %f.\n", &string[0], chi_limit);
				}


			else
			if ( strncasecmp( &string[0], "F000", 4) == 0 )
				{
				if ( fscanf( in, "%f", &CON ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				{
				CON = fabs(CON);
				HAVE_F000 = YES;
				printf("Keyword % 16s : F000 known and set to %f.\n", &string[0], CON);
				}
				}

			else
			if ( strncasecmp( &string[0], "EXCL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &exclusion_limit ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : limit for FPH-FP differences set to %f.\n", &string[0], exclusion_limit);
				}
			else
			if ( strncasecmp( &string[0], "GRAC", 4) == 0 )
				{
				if ( fscanf( in, "%d", &GRAPH_INTER ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Plot every %d cycles.\n", &string[0], GRAPH_INTER);
				DO_PLOT = YES;
				}
				}
			else
			if ( strncasecmp( &string[0], "GRAG", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Plot grayscale representation.\n", &string[0]);
				GRAYSCALE = YES;
				}
				}

			else
			if ( strncasecmp( &string[0], "PSOU", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Will write out postscript files containing the map sections.\n", &string[0]);
				MAKE_PS = YES;
				}
				}
			else
			if ( strncasecmp( &string[0], "GRAT", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Will keep conventional map plot.\n", &string[0]);
				KEEPCONV = YES;
				}
				}


			else
			if ( strncasecmp( &string[0], "GRAW", 4) == 0 )
				{
				GRAPH_WAIT = YES;
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Wait after each plot.\n", &string[0]);
				DO_PLOT = YES;
				}
				
				}
			else
			if ( strncasecmp( &string[0], "GRAS", 4) == 0 )
				{
				if ( fscanf( in, "%d", &GRAPH_SECTION ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				if ( HAVE_PGPLOT == NO )
					printf("Keyword % 16s given, but PGPLOT not defined.\n", &string[0] );
				else
				{
				printf("Keyword % 16s : Plot section %d.\n", &string[0], GRAPH_SECTION);
				DO_PLOT = YES;
				}
				
				}
			else
			if ( strncasecmp( &string[0], "TARG", 4) == 0 )
				{
				if ( fscanf( in, "%f", &TARGET_CHI ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : target value for chi^2 set to %5.2f\n", &string[0], TARGET_CHI);
				}

			else
			if ( strncasecmp( &string[0], "SCAL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &GLOBAL_SCALE ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : data will be multiplied by %5.2f\n", &string[0], GLOBAL_SCALE);
				}


			else
			if ( strncasecmp( &string[0], "AVER", 4) == 0 )
				{
				if ( fscanf( in, "%f", &AVER_SIGMA ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : sigma(F)=%5.2f for every F.\n", &string[0], AVER_SIGMA);
				}
			else
			if ( strncasecmp( &string[0], "KFOM", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SCALE_FOM ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else	
				printf("Keyword % 16s : FOMs will be multiplied by %5.2f.\n", &string[0], SCALE_FOM);
				}

			else
			if ( strncasecmp( &string[0], "MAP", 3) == 0 )
				{

	/*********************************************************************************************************************************/
	/**  Map keyword. ASCII is the default												**/
	/*********************************************************************************************************************************/
				if ( fscanf( in, "%s", &jchar[0] ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				if ( jchar[0] == 'C' || jchar[0] == 'c' )
					{
						if ( HAVE_CCP4 == NO )
						{
						printf("CCP4 map selected, but program compiled without CCP4 support. na4 set.\n");
						MAP_FORMAT = NA4_MAP;
						}
						else
						{						
						MAP_FORMAT = CCP4_MAP;
						printf("Keyword % 16s : CCP4 map file selected.\n", &string[0]);
						}
							}
				else
				if ( jchar[0] == 'N' || jchar[0] == 'n' )
					{
						MAP_FORMAT = NA4_MAP;
						printf("Keyword % 16s : na4 map file selected.\n", &string[0]);
							}
				else
				if ( jchar[0] == 'A' || jchar[0] == 'a' )
					{
						MAP_FORMAT = ASCII_MAP;
						printf("Keyword % 16s : ascii map file selected.\n", &string[0]);
							}
				else
					{
						MAP_FORMAT = ASCII_MAP;
						printf("Unknown map format selection. Using ASCII map format.\n" );
						}
				}
			else
			if ( strncasecmp( &string[0], "MAXF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &MAX_FOM ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : maximum FOM value set to %5.3f.\n", &string[0], MAX_FOM);
				}
			else
			if ( strncasecmp( &string[0], "MINF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &MIN_FOM ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}				
				else
				printf("Keyword % 16s : minimum FOM value set to %5.3f.\n", &string[0], MIN_FOM);
				}
			else
			if ( strncasecmp( &string[0], "SPAC", 4) == 0 )
				{
				if ( fscanf( in, "%d", &spacegroup ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}
				else
				printf("Keyword % 16s : space group number set to %d\n", &string[0],spacegroup );
				}
			else
			if ( strncasecmp( &string[0], "LAMB", 4) == 0 )
				{
				if ( fscanf( in, "%f", &val ) != 1 )
				{
					printf("Malformed keyword (%s).\n", &string[0] );
					exit(1);
							}
				else
				{
				ini_lambda = (double)(val);
				printf("Keyword % 16s : initial value for lambda set to %f\n", &string[0], ini_lambda );
				}
				}
			else
                        if ( strncasecmp( &string[0], "CONS", 4) == 0 )
				{
				con_lambda = YES;
				printf("Keyword % 16s : constant lambda run.\n", &string[0]);
					}
			else	
                        if ( strncasecmp( &string[0], "TRAN", 4) == 0 )
				{
				transform = YES;
				printf("Keyword % 16s : modulus of transform written.\n", &string[0]);
				}
			else
                        if ( strncasecmp( &string[0], "EXTE", 4) == 0 )
				{
				extend = YES;
				printf("Keyword % 16s : phase replacement run.\n", &string[0]);
				}
			else	
                        if ( strncasecmp( &string[0], "PATT", 4) == 0 )
				{
				PATTERSON = YES;	
				if ( DIFF_PATTERSON == YES )
					{
						printf("\n\nFlags PATTerson and DIFF_Patterson are mutually exclusive.\n\n");
						exit(1);
							}
				printf("Keyword % 16s : Patterson map run [h k l F sig(F)].\n", &string[0]);
				}

			else	
                        if ( strncasecmp( &string[0], "DIFF", 4) == 0 )
				{
				DIFF_PATTERSON = YES;				
				if ( PATTERSON == YES )
					{
						printf("\n\nFlags PATTerson and DIFF_Patterson are mutually exclusive.\n\n");
						exit(1);
							}
				printf("Keyword % 16s : Difference Patterson map run [h k l FP sig(FP) FPH sig(FPH)].\n", &string[0]);
				}

			else
                        if ( strncasecmp( &string[0], "FOM", 3) == 0 )
				{
				HAVE_FOM = YES;				
				printf("Keyword % 16s : foms available [h k l F sig(F) phi fom]\n", &string[0]);
				}
			else
                        if ( strncasecmp( &string[0], "REFL", 4) == 0 )
				{


	/*********************************************************************************************************************************/
	/**  Reflection records interpretation											 	**/
	/*********************************************************************************************************************************/

					printf("Keyword % 16s : start reading reflections.\n", &string[0]);		

					for ( i=0 ; i < MAX_NOF_REFL ; i++ )
						refl[i][4] = 0.0;		
						
									
					average_F = 0.0;
					obs = 0;
					abs_hmax = 0;
					abs_kmax = 0;
					abs_lmax = 0;

							/* For all in file ... */
					while( 1 )
					{
					if ( fscanf( in, "%f %f %f", &h, &k, &l ) != 3 )
						break;
					
									
					if ( abs( h ) > abs_hmax )
						abs_hmax = abs(h);
					if ( abs( k ) > abs_kmax )
						abs_kmax = abs(k);
					if ( abs( l ) > abs_lmax )
						abs_lmax = abs(l);
					

					
								/* Check whether it has to be rejected (file REJECT.HKL) */
					SKIP = NO;
					if ( DO_REJECT == YES )
						{
						for (i=0 ; i < nof_rej ; i++ )
							if ( nearint(h)==brejected[0][i] &&
							     nearint(k)==brejected[1][i] &&
							     nearint(l)==brejected[2][i])
							     {
							     printf("Reflection rejected : % 5d % 5d % 5d\n", 
							     nearint(h), nearint(k), nearint(l) );
							     fgets( line, 299, in );
							     SKIP = YES;
							     obs--;
							     }
								}
					if ( fgets( line, 299, in ) == NULL )
						break;
						
	/*********************************************************************************************************************************/
	/**  Start with each of the various possible formats. 										**/
	/*********************************************************************************************************************************/



					if ( PATTERSON == YES && SKIP == NO)
						{
							if ( (i=sscanf( line, "%f %f",&F,&sigF )) == 2 )
								;
							else
								{
									printf("\nProblem with reflection record number %d. Abort.\n", obs+1);
									exit(1);
										}
							
							F = fabs(F);
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F*F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( refl[obs][3] );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = 2.0*F*sigF + sigF*sigF;
							refl[obs][5] = 0.0000;
							average_F += F*F;
										}
					else

					if ( DIFF_PATTERSON == YES && SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f %f",&F,&sigF,&fph, &sigfph )) == 4 )
								;
							else
								{
									printf("\nProblem with reflection record number %d. Abort.\n", obs+1);
									exit(1);
										}
							fph = fabs( fph );
							F   = fabs( F );
							if ( exclusion_limit > 0.0 && fabs( fph - F ) >= exclusion_limit )
							{
							obs--;
							printf("Large difference (excluded) : % 5d % 5d % 5d % 15.5f % 15.5f\n",
								nearint(h),nearint(k),nearint(l),F,fph );
							}
							else
							{							
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = (F-fph)*(F-fph);
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( refl[obs][3] );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = 2.0*fabs( fph - F )*sqrt(sigF*sigF+sigfph*sigfph) + (sigF*sigF+sigfph*sigfph);
							refl[obs][5] = 0.0000;
							average_F += refl[obs][3];
							}
										}
					else

					if ( HAVE_FOM == YES && SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f %f", &F,&sigF,&phi,&fom )) == 4 )
								;
							else
								{
									printf("\nProblem with reflection record number %d. Abort.\n", obs+1);
									exit(1);
										}
							
							if ( excl_fom > 0.0 && fom < excl_fom )
								{
									obs--;
									excluded_due_to_fom++;
									if ( verbose == YES )
										printf("Low fom (excluded) : % 5d % 5d % 5d  % 5.3f\n",
											nearint(h),nearint(k),nearint(l),fom );
											
								}
							else
							{
							
							if ( F < 0.00 )
								{
									printf("Reflection with negative modulus. Phase angle : +180.0 degrees.\n");
									F = fabs(F);
									if ( phi < 0.0 )
										phi += 180.000;
									else
										phi -= 180.000;
											}
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( F );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = sigF;
							
							if ( SCALE_FOM > 0.0 )
								fom *= SCALE_FOM;
							
							if ( MAX_FOM > 0.0 && fom > MAX_FOM )
								fom = MAX_FOM;

							if ( MIN_FOM > 0.0 && fom < MIN_FOM )
								fom = MIN_FOM;
							
							
											/* FFTW uses exp(-2PIi) for forward trans */
							
							refl[obs][5] = -1.0*phi;
							refl[obs][6] = fom;
							average_F += F;
										}
											}
					else if ( SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f", &F,&sigF,&phi )) == 3 )
								;
							else
								{
									printf("\nProblem with reflection record number %d. Abort.\n", obs+1);
									exit(1);
										}

							if ( F < 0.00 )
								{
									printf("Reflection with negative modulus. Phase angle : +180.0 degrees.\n");
									F = fabs(F);
									if ( phi < 0.0 )
										phi += 180.000;
									else
										phi -= 180.000;
											}

							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( F );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = sigF;

											/* FFTW uses exp(-2PIi) for forward trans */
							
							refl[obs][5] = -1.0*phi;
							average_F += F;
										}
					obs++;

					if ( obs > MAX_NOF_REFL-2 )
						{
							printf("\n\n\nToo many reflections (limit %d). Abort.\n\n\n", MAX_NOF_REFL);
							exit( 0 );
									}

                          		}
					
					                                            		}
			else
			{
											/* this is a comment */
			if ( string[0] == '#' || string[0] == '!' || string[0] == '*' )
				{
				char junkk;
				
				fscanf( in, "%c", &junkk);
				while ( junkk != '\n' )
					fscanf(in, "%c", &junkk);
				
				}	
			else
			{
			printf("Unknown keyword : %s\n",  &string[0]);
			nof_unknown++;
			if ( nof_unknown > 10 )
				{
					printf("\n\n\nToo many errors. A missing (or extra) argument ? Abort.\n\n");
					exit(1);
						}
			}
			}					
							

														}



	fclose(in);
	
	/*********************************************************************************************************************************/
	/** End of input. Start doing things											 	**/
	/*********************************************************************************************************************************/

	
	if ( obs == 0 )
		{
			printf("\n\nNo reflections found (?).\n\n");
			exit(1);
					}
	
	
	if ( excl_fom > 0.0 && HAVE_FOM == YES )
		printf("%d reflections rejected due to FOM cutoff (Keyword EXFOm)\n", excluded_due_to_fom );

	average_F /= (float)(obs);




	/*********************************************************************************************************************************/
	/**  Attempt for origin-removed Patterson : unsuccessful									**/
	/*********************************************************************************************************************************/
	if ( (PATTERSON == YES || DIFF_PATTERSON == YES) && ORIGIN_REMOVED == YES )
	{
	for ( i=0 ; i < obs ; i++ )
		{
		amp = refl[i][3] - average_F;
		if ( amp < 0.0 )
			refl[i][5] = 180.000000000;
		refl[i][3] = fabs( amp );
		}
	average_F = 0.0;
	for ( i=0 ; i < obs ; i++ )
		average_F += refl[i][3];
	average_F /= (float)(obs);
	}
	


	/*********************************************************************************************************************************/
	/**  Highest resolution attainable												**/
	/*********************************************************************************************************************************/

	max_res = min( cell[0] / abs_hmax, cell[1] / abs_kmax, cell[2] / abs_lmax );
	



	/*********************************************************************************************************************************/
	/** Exclude reflections with F/sigF < LIMIT										 	**/
	/*********************************************************************************************************************************/

	if ( LIMIT_SIGMA > 0.0 )
	{
	thrown = 0;
	for ( i=0 ; i < obs ; i++ )
		if ( (refl[i][3] / refl[i][4]) < LIMIT_SIGMA )
			{
				thrown++;		
				refl[i][4] = -1.0;
					}
					
	printf("%d reflections rejected due to sigma cutoff (Keyword LIMIt)\n", thrown );
	
	for ( n=0 ; n < thrown ; n++)
	{
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][4] < 0.0 )
			break;
	
	for ( m=i+1 ; m < obs ; m++ )
		{
			refl[m-1][0] = refl[m][0];		
			refl[m-1][1] = refl[m][1];		
			refl[m-1][2] = refl[m][2];		
			refl[m-1][3] = refl[m][3];		
			refl[m-1][4] = refl[m][4];		
			refl[m-1][5] = refl[m][5];		
			refl[m-1][6] = refl[m][6];		
							}	

	}
	
			
	obs = obs - thrown;
	
	if ( obs <= 0 )
		{
			printf("\n\nNo reflections found (?).\n\n");
			exit(1);
					}
					

	average_F = 0.0;
	for ( i=0 ; i < obs ; i++ )
		average_F += refl[i][3];
	average_F /= (float)(obs);
	}


						



	/**************************************************************************************************************************/
	/**   Check presence of cards                                                                                            **/
	/**************************************************************************************************************************/

	printf("___________________________________________________________________________________________________________________________\n\n");

		
        if ( grid_x == 0 )
                {
                        printf("\n\n\n\n Card GRID is not present. Abort.\n\n");
                        exit( 1 );
                                        }
        if ( iuvw[0] == -1 )
                {
                        printf("\n\n\n\n Card PERM is not present. Abort.\n\n");
                        exit( 1 );
                                        }
        if ( cell[0] == 0.0 )
                {
                        printf("\n\n\n\n Card CELL is not present. Abort.\n\n");
                        exit( 1 );
                                        }
        if ( spacegroup == 0 )
                {
                        printf("\n\n\n\n Card SPACE GROUP is not present. Abort.\n\n");
                        exit( 1 );
                                        }



	/**************************************************************************************************************************/
	/**   Check fast axis                                                                                                    **/
	/**************************************************************************************************************************/
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][ iuvw[0] -1 ] < 0 )
			{
				printf("The fast changing index must be >= 0, but found a negative. Changing hemisphere ...\n\n\n\n");
				break;
						}
	if ( i != obs )
		{
			for ( i=0 ; i < obs ; i++ )
				if ( refl[i][ iuvw[0] -1 ] < 0 )	
					{
						refl[i][0] *= -1.00000;
						refl[i][1] *= -1.00000;
						refl[i][2] *= -1.00000;
						refl[i][5] *= -1.0;		/* don't forget to reflect phase angle */
						
										}
											}
							

	added_refl = 0;
	/**************************************************************************************************************************/
	/** Check for missing axial reflections						                                         **/
	/**************************************************************************************************************************/
	for ( i=0 ; i < obs ; i++ )
		if ( nearint(refl[i][ iuvw[0] -1 ]) == 0 )
			{
			search1 = -1.0*refl[i][ iuvw[1] -1 ];
			search2 = -1.0*refl[i][ iuvw[2] -1 ]; 
			
							
			for ( m=i+1 ; m < obs   ; m++ )
				if ( nearint(refl[m][ iuvw[0] -1 ]) == 0
				  && nearint(refl[m][ iuvw[1] -1 ]) == nearint(search1)
				  && nearint(refl[m][ iuvw[2] -1 ]) == nearint(search2) )
						break;
			
			
			if ( m == obs )
				{	
					if ( verbose == YES )
					printf("   Added reflection % +4d % +4d % +4d   % +12.3f  % +12.3f   % +6.1f \n", 
						(int)(-1.0*refl[i][0]), (int)(-1.0*refl[i][1]), 0, refl[i][3], refl[i][4], -1.0*refl[i][5] );
					refl[obs+added_refl][ iuvw[1] -1 ] = search1;
					refl[obs+added_refl][ iuvw[2] -1 ] = search2;
					refl[obs+added_refl][ iuvw[0] -1 ] = 0.0;
					refl[obs+added_refl][3] = refl[i][3];
					refl[obs+added_refl][4] = refl[i][4];
					refl[obs+added_refl][5] = -1.0*refl[i][5];
					refl[obs+added_refl][6] = refl[i][6];
					added_refl++;
					if ( obs + added_refl > MAX_NOF_REFL-2 )
						{
						printf("\n\n\nToo many reflections (limit %d). Abort.\n\n\n", MAX_NOF_REFL);
						exit( 0 );
								}
					
										}
											}
								
	printf("\n");								
	obs = obs + added_refl;








	/* This is the interval for writing out info about the calculation when not in VERBose mode */
	/* It is also the interval (in number of cycles) for checking whether we exceeded the time limitations */

	if ( verbose == NO )
		VERB_INTERVAL = (int)(2621440 / (4 * grid_x * grid_y * grid_z)) > 1 ? (int)(2621440 / (4 * grid_x * grid_y * grid_z)) : 2;
		
	if ( HAVE_TIME > 0 )
		VERB_INTERVAL = (int)(2621440 / (4 * grid_x * grid_y * grid_z)) > 1 ? (int)(2621440 / (4 * grid_x * grid_y * grid_z)) : 2;
	



	/**************************************************************************************************************************/
	/**   F000 related arbitrariness                                                                                         **/
	/**************************************************************************************************************************/

	if ( HAVE_F000 == YES )							/* This is not ... */
		{
										/* Square for a Patterson */		
			if ( PATTERSON == YES || DIFF_PATTERSON == YES )
				{
					CON *= CON;
					printf(" - Square F000 for Patterson calculation, F000=%f.\n", CON );
					}
				
			CON /= ( grid_x * grid_y * grid_z );

		}
	else
		{					
										/* ... but these are */
			if ( PATTERSON == YES || DIFF_PATTERSON == YES )
				{
					float maxF;
					
					maxF = 0.0;				/* If Patterson, just use the largest F^2 */  
					for ( i=0 ; i < obs ; i++ )
						if ( refl[i][3] > maxF )
							maxF = refl[i][3];
					CON = maxF / ( grid_x * grid_y * grid_z );
					printf(" - F000 not given. Set to %f\n", maxF );
					 				
							}
			else
				{						/* else, calculate F000 assuming a mean electron */
										/* density of 0.40e/A^3                          */
 					float	Vol;
 					
 										/* First a quick check on cell (never know). */
 					if ( !(cell[0] > 0.0 && cell[1] > 0.0 && cell[2] > 0.0))
 						{
 							printf("\n\nCell dimensions less or equal to zero ? Abort.\n\n");
 							exit(1);
 									}
					
					
					/* Cell volume (hopefully in A^3) */
					
 					Vol = cell[0]*cell[1]*cell[2]*sqrt(1.000+2.00*cos(cell[3]*PI/180.0)*cos(cell[4]*PI/180.0)*
 					      cos(cell[5]*PI/180.0)-cos(cell[3]*PI/180.0)*cos(cell[3]*PI/180.0)	
 					      -cos(cell[4]*PI/180.0)*cos(cell[4]*PI/180.0)-cos(cell[5]*PI/180.0)*cos(cell[5]*PI/180.0));						
 					
 					CON = 0.4000 * Vol / ( grid_x * grid_y * grid_z );
 					printf(" - F000 not given. Set to %f\n", (0.4000*Vol) );
 				
	
							}
 								}
	






	/**************************************************************************************************************************/
	/**   Info                                                                                                               **/
	/**************************************************************************************************************************/


        if ( ini_lambda < 0.0 )				/* This means lambda was not defined. Will try an automatic determination */                  	
                {
			WILL_TEST = YES;
			printf(" - Trial-and-error definition of initial lambda value.\n");
						} 
	else
	        printf(" - Initial lambda is %8.3f\n", ini_lambda );

	if ( verbose == NO )
        	printf(" - Only essential information will be written out.\n");
	else
        	printf(" - Verbose output requested.\n");
	if ( con_lambda == NO )
                printf(" - Lambda linearly depended on number of cycles.\n");
	else
		printf(" - Constant lambda requested.\n");
        if ( extend == YES )
		printf(" - Phase extension requested.\n"); 
	printf(" - Grid (along fast, medium and slow) % 5d  % 5d  % 5d\n", grid_y, grid_x, grid_z );
	printf(" - Axes permutation is fast-%c, medium-%c, slow-%c \n", ('W'+iuvw[0]), ('W'+iuvw[1]), ('W'+iuvw[2]));



	printf("\n\n");




	/**************************************************************************************************************************/
	/**   Check grid ...                                                                                                     **/
	/**************************************************************************************************************************/


	if ( get_grid( grid_x - 0.10 ) != grid_x )
		{
			printf("\n\nNumber of grid points (%d) has a large prime factor.\n\n", grid_x);
                        exit( 1 );
						}

	if ( get_grid( grid_y - 0.10 ) != grid_y )
		{
			printf("\n\nNumber of grid points (%d) has a large prime factor.\n\n", grid_y);
                        exit( 1 );
						}

	if ( get_grid( grid_z - 0.10 ) != grid_z )
		{
			printf("\n\nNumber of grid points (%d) has a large prime factor.\n\n", grid_z);
                        exit( 1 );
						}





/*****************************************************************************************************************************************/
/** 	Quick test on how much memory we are about to grab ... 									 	**/
/*****************************************************************************************************************************************/
	mem_req = grid_z * grid_x * (grid_y+2) * 6.0 * 4.0 / ( 1024.0 * 1024.0 ); 
	if ( mem_req < 64.0 )
		{
		if ( verbose == YES )
			printf(" - Data structures require %4.1f MBytes of memory.\n", mem_req );
		}
	else
		{
		printf(" - Data structures require %4.1f MBytes of memory.\n", mem_req );	
		printf("   If everything comes to a halt, you will know what went wrong.\n");
		}
		



	/**************************************************************************************************************************/
	/**   Try to allocate space                                                                                              **/
	/**************************************************************************************************************************/
	if ( verbose == YES )
		printf(" - About to allocate memory.                                  \n");

	Fobs_1   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );  	/* These routines come from the public sector of NR */
	SigF_1   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );
	PriorA_1 = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );

	for ( w = 1; w <= grid_z ; w++ )
    	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <= grid_y+2 ; u++ )
			{
				  Fobs_1[w][v][u] = 0.0;
				PriorA_1[w][v][u] = 0.0;
				  SigF_1[w][v][u] = 0.0;
                                      				}



	/**************************************************************************************************************************/
	/**   FFTW's Wisdom file and plan construction. See FFTW manual for more info                                            **/
	/**************************************************************************************************************************/

	/* I bet this won't work on VMS */
	
	if ( getenv("HOME") == NULL )
		{
			printf("HOME symbol missing : Will write FFTW's wisdom file in the current directory.\n");
			strcpy( wisdom_name, ".FFTW_wisdom");
			wisdom = fopen( ".FFTW_wisdom", "r" );			
						}
	else
		{
			strcpy( wisdom_name, getenv("HOME") );
			strcat( wisdom_name, "/.FFTW_wisdom");
			wisdom = fopen( wisdom_name, "r" );
								}




	if ( wisdom == NULL )
		printf(" - FFTW's wisdom file not present. It will be created.\n");
	else
		{
		if ( FFTW_FAILURE == fftw_import_wisdom_from_file( wisdom ) )
			printf(" - FFTW failed to read the wisdom file (%s). Continue without wisdom.\n", wisdom_name );
		else
			fclose( wisdom );	
		}
		

	if ( verbose == YES )
		printf(" - FFTW is learning how to do FFTs  ...  \n");



        p    = rfftw3d_create_plan( grid_z, grid_x, grid_y, FFTW_REAL_TO_COMPLEX,  FFTW_MEASURE | FFTW_IN_PLACE | FFTW_USE_WISDOM );
        pinv = rfftw3d_create_plan( grid_z, grid_x, grid_y, FFTW_COMPLEX_TO_REAL,  FFTW_MEASURE | FFTW_IN_PLACE | FFTW_USE_WISDOM );


	if ( verbose == YES )
		{
			printf(" - FFTW learned how to do FFTs.    \n");
			printf(" - Saving FFTW's wisdom file ...    \n");
				}
	



	wisdom = fopen( wisdom_name, "w" );
	if ( wisdom == NULL )
		{
			printf("Can not open FFTW's wisdom file (?). Abort.\n");
			exit(1);
							}
	fftw_export_wisdom_to_file( wisdom );
	fclose( wisdom );
	
	
		
								
	/**************************************************************************************************************************/
	/**   Load onto arrays ...                                                    		                                 **/
	/**************************************************************************************************************************/


	/* This is arbitrary, and probably wrong, but you can change it */
	
	 
	if ( 	(DIFF_PATTERSON == NO && PATTERSON == NO && average_F > 1000.0 ) ||
		((DIFF_PATTERSON == YES || PATTERSON == YES ) && average_F > 1000000.0 ))
	{
	printf("___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________\n\n");
	printf("    The mean amplitude of the input data appears to be too large. If the data are not on an (approximate) absolute scale\n");
	printf("    and you see very sharp peaks in the MaxEnt map, then beware : the calculation you are performing may be wrong.\n");
	printf("___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________\n\n");
	}
	
	
	if ( verbose == YES )
		printf("     There are %d observations with <F>=%10.2f                  \n", obs, average_F);

	if ( GLOBAL_SCALE > 0.0 )
		{
			for ( i=0 ; i < obs ; i++ )
				{
					refl[i][3] *= GLOBAL_SCALE;
					refl[i][4] *= GLOBAL_SCALE;
					if ( refl[i][4] < 1.0 )				/* THIS IS ARBITRARY AND WRONG. HOPEFULLY NOT */
											/* MANY REFLECTIONS WILL HAVE a sig(F) < 1.0 */
					{						/* On a second thought, I don't understand */
											/* what this line is doing here. Watch this space*/
					
					printf("Reflection with sigma(|F|) < 1.0. Set to 1.0.\n");
					refl[i][4] = 1.0;
						}
							}		
					
		}
	else
	{
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][4] < 1.0 )
			{
				printf("Reflection with sigma(|F|) < 1.0. Set to 1.0.\n");
				refl[i][4] = 1.0;
						}
	}


	if ( verbose == YES )
		printf(" - Loading data on arrays ...                                 \n - Do not panic yet ...  \n");



	total_number_of_obs = obs;
	
	/*********************************************************************************************************************************/
	/**  Loading data on arays 													**/
	/*********************************************************************************************************************************/

	for ( i=0 ; i < obs ; i++ )
		{
										
			A = refl[i][3] * cos ( PI * refl[i][5] / 180.0 );	/* Real and imaginary */
			B = refl[i][3] * sin ( PI * refl[i][5] / 180.0 );
			w = refl[i][ iuvw[2] -1 ];				/* u,v,w are the coordinates of the reflection */ 
			v = refl[i][ iuvw[1] -1 ];				/* in the FFT array */
			u = 2*refl[i][ iuvw[0] -1 ] +1;
			
			if ( v < 0 )						/* The data structure for FFTW is described in its */
				v = grid_x + v;					/* manual, but the general idea is very similar to */
			if ( w < 0 )						/* the one seen in NR */
				w = grid_z + w;
			v++;
			w++;
			
			chirefl[i][0] = w;			/* This is for much later, when we will calculate the contribution */
			chirefl[i][1] = v;			/* of each reflection to the CHI**2 statistic */
			chirefl[i][2] = u;
			
			



	/*********************************************************************************************************************************/
	/**  First case : FOM not given													**/
	/*********************************************************************************************************************************/
			if ( HAVE_FOM == NO )			
			{
			PriorA_1[w][v][u]   = A;		
			PriorA_1[w][v][u+1] = B;
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			SigF_1[w][v][u]     = refl[i][4];
			SigF_1[w][v][u+1]   = 0.0;
			}
			else
			{
 	/*********************************************************************************************************************************/
	/**  Second case : known FOM. We now have to convert the structure factor probability locus to a 2D Gaussian			**/
	/*********************************************************************************************************************************/

			PriorA_1[w][v][u]   = A*refl[i][6];	/* Conventional synthesis weighted by fom */
			PriorA_1[w][v][u+1] = B*refl[i][6];
			
			
										/* Leaving dangerously : phase-less reflections */
			if ( PHASELESS && ( refl[i][6] < FOM_PHASELESS ))
			{
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			if ( refl[i][4] > 1.0 )
				SigF_1[w][v][u]     = -refl[i][4];
			else
				SigF_1[w][v][u] = -1.0;				/* We will use fom to adjust speed of convergence */
			SigF_1[w][v][u+1]   = refl[i][6];
			phasenot++;
			}
			else
			{
			
								/* Get A,B,sigA,sigB on a frame that has the real axis along the */
								/* original F, and the imaginary axis 90 degrees anticlockwise */
			
			get_param( refl[i][3], refl[i][4], refl[i][6], &length ,&psigA, &psigB );
			length *=  refl[i][3];
			psigA  *=  refl[i][3];
			psigB  *=  refl[i][3];
			if ( psigA < 1.00 )
				{
					psigA = 1.0;
					if ( verbose == YES )
						printf("Sigma less than 1.0. Corrected.\n");
				}
			if ( psigB < 1.00 )
				{
					psigB = 1.0;
					if ( verbose == YES )
						printf("Sigma less than 1.0. Corrected.\n");
				}
				
			Fobs_1[w][v][u]     = length * cos ( PI * refl[i][5] / 180.0 );
			Fobs_1[w][v][u+1]   = length * sin ( PI * refl[i][5] / 180.0 );
			SigF_1[w][v][u]     = psigA;
			SigF_1[w][v][u+1]   = psigB;	


								/* Now, what we give Maxent is the values of A and B in the normal */
								/* complex plane, and the sigmas which refer to a skewed axes system */
								/* with A along the vector of Fo, and B 90 degrees away */

			if ( verbose == YES )
				if ( i % (int)(obs*0.10) == 0 )
					printf("    % 4d%% of reflections to go.\n", 100-(int)((i*100)/obs));


					}
				}
			}




							
	Fobs_1[1][1][1] = 0.0;		/* This is irrelevant : F000 is only used to define the mean density of the initial */
	Fobs_1[1][1][2] = 0.0;		/* uniform prior during the actual maxent iteration */
	SigF_1[1][1][1] = 0.0;
	SigF_1[1][1][2] = 0.0;
	PriorA_1[1][1][1] = 0.0;
	PriorA_1[1][1][2] = 0.0;

	if ( PHASELESS && HAVE_FOM )
	printf(" - %d reflections with FOM<%5.3f entered the calculation without phase restraints.\n", phasenot, FOM_PHASELESS);
	



 	/*********************************************************************************************************************************/
	/**  This simply writtes out the modulus of the first section of the given data. Useful only for plotting 			**/
	/*********************************************************************************************************************************/
	if ( transform == YES )
		{
			if ( verbose == YES )
				printf(" - About to write out the zero section of the starting transform.\n");
			out = fopen("START_TRANS.dat", "w");
			for ( i=-grid_x/2 ; i <= grid_x/2 ; i++ )
				{
					for ( m=-grid_y+2 ; m <= grid_y-2 ; m+=2 )
						{
							rec_angle = PI - PI * cell[ 2 + iuvw[2]]/180.0;
							rec_a = (float)(i) / cell[iuvw[1]-1] + 0.50*m*cos(rec_angle)/cell[iuvw[0]-1];
							rec_b = 0.50*m*sin(rec_angle)/cell[iuvw[0]-1];
							
							u = m;
							v = i;
							if ( u < 0 )
								{
									u = -1 * u;
									v = -1 * v;
											}

							if ( v < 0 )
								v = grid_x + v;
							v++;
							u++;
							A = PriorA_1[1][v][u];
							B = PriorA_1[1][v][u+1];
							fprintf(out, " % 10.8f  % 10.8f  % 15.3f\n", rec_a, rec_b, sqrt( A*A + B*B ) );
									}
										}
			fclose(out);
											}
											 
						
						
			

 	/*********************************************************************************************************************************/
	/**  This the conventional map calculation ...											**/
	/*********************************************************************************************************************************/

	if ( verbose == YES )
		printf(" - About to calculate conventional Fourier transform of data   \n");
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );


 	/*********************************************************************************************************************************/
	/** ... and output.													 	**/
	/*********************************************************************************************************************************/

	if ( verbose == YES )
		printf(" - Write out conventional Fourier transform (file conventional.map)\n");
	name[0] = "conventional.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : conventional synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], PriorA_1, grid_z, grid_x, grid_y, iuvw, 2, &details[0] );
	










 	/*********************************************************************************************************************************/
	/** Plot a (user defined) section from the conventional map using PGPLOT routines. 					 	**/
	/*********************************************************************************************************************************/

	
#ifndef NOPGPLOT
	if ( DO_PLOT == YES )
	{


		
						/* Make a postscript file containing a section from the conventional map */
	if ( MAKE_PS == YES )
	{


	if( cpgopen("CONVENTIONAL.ps/cps") <= 0 )
		{
			printf("Can not open postscript file for plot. PSOUt unset.\n");
			MAKE_PS = NO;
					}
	else
		{
 	/*********************************************************************************************************************************/
	/**  Colours for contours 													**/
	/*********************************************************************************************************************************/

			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);


 	/*********************************************************************************************************************************/
	/**  Depending on the axes permutation, calculate angle and cell axes lengths for the section					**/
	/*********************************************************************************************************************************/

			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}


 	/*********************************************************************************************************************************/
	/**  This is the transformation  matrix for PGPLOT 										**/
	/*********************************************************************************************************************************/
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;

 	/*********************************************************************************************************************************/
	/**  and this is the range of values along the horizontal and vertical axes 							**/
	/*********************************************************************************************************************************/
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin( xmin, xmax, ymin, ymax );

									}
	



	if ( GRAPH_SECTION < 1 || GRAPH_SECTION > grid_z )
		{
			printf("Section for plot outside limits. Set to 0.\n");
			GRAPH_SECTION = 1;
						}


 	/*********************************************************************************************************************************/
	/**  The function plot_section() is actually doing the plot									**/
	/*********************************************************************************************************************************/

	if ( DO_PLOT == YES )
		plot_section( "Conventional map", PriorA_1, grid_z, grid_x, grid_y);


	cpgclos();

	}




				
					/* Now, repeat for X-window */
				
				

	if( cpgopen("/XWIN") <= 0 )
		{
			printf("Can not open X window for plot. Graphics set to OFF.\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);



 	/*********************************************************************************************************************************/
	/**  Colours for contours depend on whether we also plot a grayscale representation or not					**/
	/*********************************************************************************************************************************/

			if  (GRAYSCALE == YES )
			{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);
			}
			else
			{
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 1.0, 0.1 ,0.1);
			cpgscr( 18, 1.0, 0.2 ,0.2);
			cpgscr( 19, 1.0, 0.3 ,0.3);
			cpgscr( 20, 1.0, 0.4 ,0.4);
			cpgscr( 21, 1.0, 0.5 ,0.5);
			cpgscr( 22, 1.0, 0.6 ,0.6);
			cpgscr( 23, 1.0, 0.7 ,0.7);
			cpgscr( 24, 1.0, 0.8 ,0.8);
			cpgscr( 25, 1.0, 0.9 ,0.9);
			cpgscr( 26, 1.0, 1.0 ,1.0);
			}


 	/*********************************************************************************************************************************/
	/**  Depending on the axes permutation, calculate angle and cell axes lengths for the section					**/
	/*********************************************************************************************************************************/

			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}


 	/*********************************************************************************************************************************/
	/**  This is the transformation  matrix for PGPLOT 										**/
	/*********************************************************************************************************************************/
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;

 	/*********************************************************************************************************************************/
	/**  and this is the range of values along the horizontal and vertical axes 							**/
	/*********************************************************************************************************************************/
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin( xmin, xmax, ymin, ymax );

									}
	



	if ( GRAPH_SECTION < 1 || GRAPH_SECTION > grid_z )
		{
			printf("Section for plot outside limits. Set to 0.\n");
			GRAPH_SECTION = 1;
						}
							}


 	/*********************************************************************************************************************************/
	/**  The function plot_section() is actually doing the plot									**/
	/*********************************************************************************************************************************/

	if ( DO_PLOT == YES )
		plot_section( "Conventional map", PriorA_1, grid_z, grid_x, grid_y);
		
#endif			
		







	/**************************************************************************************************************************/
	/**   Trial-and-error to get a reasonable initial value for lambda                                                       **/
	/**************************************************************************************************************************/
	if ( WILL_TEST == YES )
	{
	printf("___________________________________________________________________________________________________________________________\n");

	
	ini_lambda = 0.01000000;				/* This arbitrary assumption can get us into trouble with some data sets */
	printf("\n - Now trying lambda = % 12.3f\n", ini_lambda );
	while( maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y ) > 0.0 )
		{
			ini_lambda *= (double)(10.00000);
			if ( verbose == YES )
				printf("\n\n");
			printf(" - Now trying lambda = % 12.3f\n", ini_lambda );
					}
					
	ini_lambda /= (double)(10.0000);
	printf("\n - Initial value for lambda set to %f\n", ini_lambda );
	WILL_TEST = NO;
	}
	





 	/*********************************************************************************************************************************/
	/**  Do the same thing (as with the conventional synthesis above) for opening the graphics window for the maxent map.	 	**/
	/*********************************************************************************************************************************/

		
#ifndef NOPGPLOT
	if ( KEEPCONV == YES )
	{
	if( cpgopen("/XWIN") <= 0 )
		{
			printf("Can not open X window for plot. Graphics set to OFF.\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			if  (GRAYSCALE == YES )
			{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);
			}
			else
			{
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 1.0, 0.1 ,0.1);
			cpgscr( 18, 1.0, 0.2 ,0.2);
			cpgscr( 19, 1.0, 0.3 ,0.3);
			cpgscr( 20, 1.0, 0.4 ,0.4);
			cpgscr( 21, 1.0, 0.5 ,0.5);
			cpgscr( 22, 1.0, 0.6 ,0.6);
			cpgscr( 23, 1.0, 0.7 ,0.7);
			cpgscr( 24, 1.0, 0.8 ,0.8);
			cpgscr( 25, 1.0, 0.9 ,0.9);
			cpgscr( 26, 1.0, 1.0 ,1.0);
			}


			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin( xmin, xmax, ymin, ymax );

									}
										}
#endif	
	
	printf("\n\n\n");












 	/*********************************************************************************************************************************/
	/** Ready to roll ...													 	**/
	/*********************************************************************************************************************************/


	printf("___________________________________________________________________________________________________________________________\n\n");
	printf(" - MAXENT starts here                                   \n\n");


 


 	/*********************************************************************************************************************************/
	/**  This is the maxent iteration												**/
	/*********************************************************************************************************************************/

 	R_factor = maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y );


	printf("___________________________________________________________________________________________________________________________\n\n");


















 	/*********************************************************************************************************************************/
	/**  Write postscript if requested												**/
	/*********************************************************************************************************************************/





#ifndef NOPGPLOT

	if ( MAKE_PS == YES )
	{


	if( cpgopen("GRAPHENT.ps/cps") <= 0 )
		{
			printf("Can not open postscript file for plot. PSOUt unset.\n");
			MAKE_PS = NO;
					}
	else
		{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);


			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin( xmin, xmax, ymin, ymax );

									}

		plot_section( "GraphEnt synthesis", PriorA_1, grid_z, grid_x, grid_y);
		cpgclos();
										}
#endif	







 	/*********************************************************************************************************************************/
	/**  If returned value is negative : convergence not achieved									**/
	/*********************************************************************************************************************************/


	if ( R_factor < 0.0 )
		{
			printf("\n\nCONVERGENCE NOT ACHIEVED.\n");
			printf("The final R-factor between the observed\n");
			printf("and calculated amplitudes is %10.7f \n\n\n", fabs( R_factor ));
                        printf("If the R-factor is higher than the Rsymm of the data\n");
                        printf("you can try decreasing the initial value of lambda  \n");
                        printf("and run the programme again. See the documentation  \n");
                        printf("for details on how to do that.                \n\n\n\n");
                                       								}
	else
		{
			printf("\n\nCONVERGENCE ACHIEVED.\n");
			printf("The final R-factor between the observed\n");
			printf("and calculated amplitudes is %10.7f \n\n\n", fabs( R_factor ));
													}





 	/*********************************************************************************************************************************/
	/**  I haven't used this option for ages and I don't know if it works, and it is not in the documentation, and forget it	**/
	/*********************************************************************************************************************************/
	/**************************************************************************************************************************/
	/**   If phase extension requested : transform MAXENT, and for every grid point in Fobs, assign PHIc to Fo.              **/
	/**   Then, transform FoPHIc and write out new (conventional) map.                                                       **/
	/**************************************************************************************************************************/
	if ( extend == YES && R_factor > 0.000)
	{
	norm = 1.0 / ( grid_z * grid_x * grid_y );
	rfftwnd_one_real_to_complex( p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );


	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u += 2 )
		if ( (int)( Fo = sqrt( Fobs_1[w][v][u]*Fobs_1[w][v][u] + Fobs_1[w][v][u+1]*Fobs_1[w][v][u+1] )) != 0 &&
		     (int)( Fc = sqrt( PriorA_1[w][v][u]*PriorA_1[w][v][u] + PriorA_1[w][v][u+1]*PriorA_1[w][v][u+1])) != 0 )
			{
	  		 	Fobs_1[w][v][u]   = PriorA_1[w][v][u]   * Fo / Fc;
	  		 	Fobs_1[w][v][u+1] = PriorA_1[w][v][u+1] * Fo / Fc;
						}

	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&Fobs_1[1][1][1]), NULL );
	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u++  )
              	Fobs_1[w][v][u] *= norm;
					
			
	if ( verbose == YES )
		printf(" - About to write out extend.map                              \n");
	name[0] = "extend.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : extension synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], Fobs_1, grid_z, grid_x, grid_y, iuvw, 2, &details[0] );
	printf("\n\n\n");
	



	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u++  )
              	PriorA_1[w][v][u] *= norm;
									}












	/**************************************************************************************************************************/
	/**   Now write out MAXENT.MAP                                                                                           **/
	/**************************************************************************************************************************/


	if ( verbose == YES )
		printf(" - Write out maxent.map map file.                                     \n");
	name[0] = "maxent.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : maxent (?) synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], PriorA_1, grid_z, grid_x, grid_y, iuvw, 2,  &details[0] );
	printf("\n\n\n");


 	/*********************************************************************************************************************************/
	/**  This is the modulus of the zero section of the maxent's map transform. For preparing graphs only				**/
	/*********************************************************************************************************************************/
	if ( transform == YES )
		{
			rfftwnd_one_real_to_complex( p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );
			if ( verbose == YES )
				printf(" - About to write out the zero section of the maxent transform.\n");
			out = fopen("MAXENT_TRANS.dat", "w");
			for ( i=-grid_x/2 ; i <= grid_x/2 ; i++ )
				{
					for ( m=-grid_y+2 ; m <= grid_y-2 ; m+=2 )
						{

							rec_angle = PI - PI * cell[ 2 + iuvw[2]]/180.0;
							rec_a = (float)(i) / cell[iuvw[1]-1] + 0.5*m*cos(rec_angle)/cell[iuvw[0]-1];
							rec_b = 0.5*m*sin(rec_angle)/cell[iuvw[0]-1];
							
							u = m;
							v = i;
							if ( u < 0 )
								{
									u = -1 * u;
									v = -1 * v;
											}

							if ( v < 0 )
								v = grid_x + v;
							v++;
							u++;

							A = PriorA_1[1][v][u];
							B = PriorA_1[1][v][u+1];
							fprintf(out, " % 10.8f  % 10.8f  % 15.3f\n", rec_a, rec_b, sqrt( A*A + B*B ) );
									}
					fprintf(out, "\n");
										}
			fclose(out);
											}
											 




 	/*********************************************************************************************************************************/
	/**  Calculate contribution of each reflection to the CHI^2 test. This uses information produced from the maxent() function	**/
	/*********************************************************************************************************************************/
							
	if ( R_factor > 0.000 )
	{

	if ( verbose == YES )
		printf(" - Calculating table of largest contributions to chi**2\n");
		
	mean = 0.0;
	max  = 0.0;
	for ( i=0 ; i < chitable ; i++ )
		{
			val = chicontrib[i];
			mean += val;
			if ( val > max )
				max = val;
						}
	mean /= (float)(chitable);

	rms  = 0.0;						/* Find rms contribution of all reflections to chi**2 */
	for ( i=0 ; i < chitable ; i++ )
		rms += (chicontrib[i]-mean)*(chicontrib[i]-mean);
	rms /= (float)(chitable-1);
	rms = sqrt( rms );
	
	if ( verbose == YES )
		printf(" - Will write out all reflections contributing to chi^2 by more than %f times the rmsd of all contributions.\n",
			chi_limit );
			
 	/*********************************************************************************************************************************/
	/** and this plots a graph of the CHI^2 contributions 										**/
	/*********************************************************************************************************************************/

#ifndef NOPGPLOT
	if ( DO_PLOT == YES )
	{
	if( cpgopen("/XWIN") <= 0 )
		{
			printf("Can not open X window for plot.\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( 0, chitable, 0.0, max*1.050 );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
			cpgmtxt("t", 1.0, 0.0, 0.0, "chi**2 contributions");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < chitable ; i++ )
				cpgpt1( (float)(i), chicontrib[i], -2 );
			
			cpgslw(1);
			cpgsls(4);
    			cpgsci(2);
			for ( val = mean + rms ; val < max ; val += rms )
				{
					cpgmove( 0.0, val );
					cpgdraw( (float)(chitable), val );
						}
			
			while ( getchar() == EOF )
				;


 	/*********************************************************************************************************************************/
	/**  Write it to a postscript file as well.											**/
	/*********************************************************************************************************************************/
						}

	if( cpgopen("CHIcontributions.ps/cps") <= 0 )
		{
			printf("Can not open postscript file for plot.\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( 0, chitable, 0.0, max*1.050 );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
			cpgmtxt("t", 1.0, 0.0, 0.0, "chi**2 contributions");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < chitable ; i++ )
				cpgpt1( (float)(i), chicontrib[i], -2 );
			
			cpgslw(1);
			cpgsls(4);
    			cpgsci(2);
			for ( val = mean + rms ; val < max ; val += rms )
				{
					cpgmove( 0.0, val );
					cpgdraw( (float)(chitable), val );
						}
						
						}


	cpgend();

	}
#endif	


 	/*********************************************************************************************************************************/
	/**  Write indeces of reflections with a large contribution to CHI^2 to a file (suspect data)					**/
	/*********************************************************************************************************************************/

	
	out = fopen("CHIcontributions.dat", "w" );

	for ( i=0 ; i < chitable ; i++ )
		if ( (chicontrib[i]-mean)/rms > chi_limit )
		{
		w = chipointers[i][0];
		v = chipointers[i][1];
		u = chipointers[i][2];
		
		for ( m=0 ; m < obs ; m++ )
			if ( chirefl[m][0] == w && chirefl[m][1] == v && chirefl[m][2] == u  )
				{
				fprintf( out, " % 4d % 4d % 4d   % 15.5f\n", nearint(refl[m][0]), nearint(refl[m][1]), 
									     nearint(refl[m][2]), chicontrib[i] );
				break;
				}
			
		if ( m == obs )
			fprintf(out, "Can not find reflection index (???). Panic.\n");
		}
	fclose( out  );
	}




	t2 = time(0);
	printf("\n\n\nNormal termination ? (%d seconds)\n", (int)(t2-t1));
	



}


































































































/**********************************************************************************************************************************/
/**	                                                                                                                         **/
/**	Maximise configurational entropy of image subject to the constrain that its Fourier components are consistent with       **/
/**	the observed data. Gull, S.F. & Daniell, G.J., 1978, Nature, 272, 686-690                                                **/
/**	                                                                                                                         **/
/**********************************************************************************************************************************/
float	maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y )
float	***Fobs_1;
float	***SigF_1;
float	***PriorA_1;
double	ini_lambda;
int	grid_z, grid_x, grid_y;
{

	/* For FFT */
	float	***PriorB_1;    
	float	***Backup;    


	/* For fast access */
	float	*Fobs, *SigF, *PriorA, *PriorB, *Back;


	/* Rest */   
	float	chi_p;	
	float	d_chi;
   	int	u, v, w;
	double	lambda;
	float	sum1, sum2;
	float	amp1, amp2;
	float	s, sph;
	float	norm;
        float	val;
	float	sumFo;
	int	nof_obs;
	float	A, B;
	int	cycle;
	int	converged;
	int	axial;
	float	ac,bc,ao,bo,pho,phc,phdif; 
	float	ampo, ampc, phase, ampd;
	float	jjj, backup_chi;
	float	phase_diff;
	char	pgtitle[80];
	float	intersum;
	int	c;
	int	gridprod;
	int	index;
	time_t	tstart, tend, ttest;
	float	sig1, sig2;
	float	sum, ent;	
	double 	const_ent;
	int	nof_phaseless;
	int	FALSE_ALARM = NO;
	
	
	
	


	Fobs 	= &Fobs_1[1][1][1];
	SigF 	= &SigF_1[1][1][1];
	PriorA 	= &PriorA_1[1][1][1];
	gridprod= grid_z * grid_x * (grid_y+2);

	/**************************************************************************************************************************/
	/**   Number of observed components and Sum(Fo) for R-factor.                                                            **/
	/**************************************************************************************************************************/
	norm = 1.0 / ( grid_z * grid_x * grid_y );

	axial   = 0;
	nof_obs = 0;
	sumFo   = 0.0;
	nof_phaseless = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <  grid_y ; u += 2 )
			if ( (int)(SigF_1[w][v][u]) != 0 )
				{
					if ( v == 1 )
						axial++;

					if ( (int)(SigF_1[w][v][u]) < 0 )
						nof_phaseless++;
						
					nof_obs++;
					sumFo += sqrt( Fobs_1[w][v][u]*Fobs_1[w][v][u] + Fobs_1[w][v][u+1]*Fobs_1[w][v][u+1] );
                                  					}
	nof_obs = nof_obs - (axial/2);

	if ( HAVE_FOM == YES )
		nof_obs = (nof_obs-nof_phaseless)*2 + nof_phaseless;
						




	/**************************************************************************************************************************/
	/**   Allocate space for second copy of prior & back-up                                                                  **/
	/**************************************************************************************************************************/
	PriorB_1 = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );
	Backup   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );

	PriorB = &PriorB_1[1][1][1];
	Back   = &Backup[1][1][1];




	/**************************************************************************************************************************/
	/**   Prepare initial (uniform) prior.                                                                                   **/
	/**************************************************************************************************************************/
	for ( index=0 ; index < gridprod ; index++ )
		{						/* CON has been calculated from main() based on the assigned or */
				PriorA[index] = CON;		/* given value of the F000 term. Note that we do not */
				PriorB[index] = CON;		/* expicitly constrain F000 during the iteration */
				
                                      				}





	/**************************************************************************************************************************/
	/** A non-uniform prior for Patterson functions ? : NOT GOOD (CAN'T DEAL WITH NON-PRIMITIVE, ADDITONAL AD HOCKERIES, ... **/
	/**************************************************************************************************************************/
		
	if ( (PATTERSON == YES || DIFF_PATTERSON == YES) && MAKE_NONUNIFORM == YES )
	{
	float	fooo;
	float	pseudo_at;
	float	dens_origin;
	float	res;
	float	fr[3];
	int	uu, vv, ww;
	float	sum, scale, con;
	
	fooo 	      = CON * grid_z * grid_x * grid_y;			/* This is the given F000 */
	pseudo_at     = sqrt(fooo) / 12.0;				/* Let's call this `effective number of carbon atoms' */
	dens_origin   = fooo / pseudo_at;				/* expected density of origin peak */
	
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y/2+1 ; u++ )
			{						
									/* fr[] are fractional coordinates of grid point along a,b,c */
									
				fr[ iuvw[0]-1] = (float)(u-1) / (float)(grid_y);
				fr[ iuvw[1]-1] = (float)(v-1) / (float)(grid_x);
				fr[ iuvw[2]-1] = (float)(w-1) / (float)(grid_z);
				if ( fr[0] > 0.50 )
					fr[0] -= 1.00;
				if ( fr[1] > 0.50 )
					fr[1] -= 1.00;
				if ( fr[2] > 0.50 )
					fr[2] -= 1.00;
					
				res = sqrt(  fr[0]*fr[0]*cell[0]*cell[0]
				           + fr[1]*fr[1]*cell[1]*cell[1]
				           + fr[2]*fr[2]*cell[2]*cell[2]
				           + 2.0*fr[1]*fr[2]*cell[1]*cell[2]*cos(PI*cell[3]/180.0)
				           + 2.0*fr[0]*fr[2]*cell[0]*cell[2]*cos(PI*cell[4]/180.0)
					   + 2.0*fr[0]*fr[1]*cell[0]*cell[1]*cos(PI*cell[5]/180.0) );

				PriorA_1[w][v][u] = 10000.0 * exp( -11.0450 * ( res * res) / (max_res * max_res )); 
				
				
									/* Use centre of symmetry to generate the other half of the */
									/* origin peak (want to make sure that our prior has a centre of*/
									/* symmetry) */
				uu = -u+1;
				vv = -v+1;
				ww = -w+1;
				PriorA_1[ww < 0 ? grid_z + ww + 1 : ww + 1]
				        [vv < 0 ? grid_x + vv + 1 : vv + 1]
				        [uu < 0 ? grid_y + uu + 1 : uu + 1] = PriorA_1[w][v][u];
				        
				
					}
					
	
	if ( PEAK_BACKGROUND > 0.0 )
	{
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
	       		PriorA_1[w][v][u] = PriorA_1[w][v][u] + 10000.0 * PEAK_BACKGROUND * (1.0000 - PEAK_BACKGROUND);
	}
	
					
	sum = 0.0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
			sum += PriorA_1[w][v][u];
	
	
	if ( PEAK_BACKGROUND > 0.0 )
	{
	scale = fooo / sum;
	con   = 0.0;
	}
	else
	{
	scale = dens_origin / sum;
	con   = (fooo - dens_origin) / (grid_z*grid_x*grid_y);
	}
		
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
			{
				PriorA_1[w][v][u] = PriorA_1[w][v][u]*scale + con;
				PriorB_1[w][v][u] = PriorA_1[w][v][u];
					}
					
	}
		
				








	/**************************************************************************************************************************/
	/**   Start iteration.                                                                                                   **/
	/**************************************************************************************************************************/
	chi_p  = 0.0;
	d_chi  = 1000000000;
	lambda = ini_lambda;
	cycle  = 0;


	tstart = time(NULL);
	while ( 1 )
	{






	if ( con_lambda == NO && cycle > 1  )		/* As long as the calculation is not diverging, increase lambda on every cycle */
		lambda *= (double)(1.0200000000);


		
												/* Plot section in graphics window */
	if ( DO_PLOT == YES && (cycle)%GRAPH_INTER == 0 && (cycle > 0 || MAKE_NONUNIFORM == YES ) && WILL_TEST == NO )
		{
		if ( GRAPH_WAIT == YES )
			printf("\n");
		sprintf( pgtitle, "Maxent map, Cycle %d", cycle );
		plot_section( pgtitle, PriorA_1, grid_z, grid_x, grid_y);
		}





	/**************************************************************************************************************************/
	/**   Calculate entropy of current map                                                                                   **/
	/**************************************************************************************************************************/

	if ( SHOW_ENTROPY == YES )		/* This calculates the relative entropy as a fraction of its maximum value (for a */
	{					/* uniform map). */
	int	w, v, u;
	
	sum = 0.0;
        for ( w=1 ; w <= grid_z ; w++ )
        for ( v=1 ; v <= grid_x ; v++ )
        for ( u=1 ; u <= grid_y ; u++ )
		sum += PriorA_1[w][v][u];

	const_ent = - log( 1.000 / ( grid_z * grid_x * grid_y  )); 
	ent = 0.0;
        for ( w=1 ; w <= grid_z ; w++ )
        for ( v=1 ; v <= grid_x ; v++ )
        for ( u=1 ; u <= grid_y ; u++ )
                {
                        val = PriorA_1[w][v][u];
			ent += -( val / sum ) * log( val / sum );
				}
	ent = ent / const_ent; 
	}





	/**************************************************************************************************************************/
	/**   Take transform of current prior.                                                                                   **/
	/**************************************************************************************************************************/
	rfftwnd_one_real_to_complex( p, (fftw_real *)(PriorA), NULL );









	/**************************************************************************************************************************/
	/**   If about to finish, re-calc and save contribution of each reflection to chi**2 for data diagnostic purposes         */
	/**************************************************************************************************************************/

	if ( ( TARGET_CHI > 0.0 && (chi_p-d_chi) < TARGET_CHI ) || (chi_p-d_chi) < (nof_obs) )
	{

	if ( HAVE_FOM == NO )
	{
	chitable = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <  grid_y ; u += 2 )
			{
				if ( (int)(SigF_1[w][v][u]) != 0 )
					{
					s  = SigF_1[w][v][u];
					ac = PriorA_1[w][v][u];
					bc = PriorA_1[w][v][u+1];
					ao = Fobs_1[w][v][u];
					bo = Fobs_1[w][v][u+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] = ( amp1 - amp2 ) * ( amp1 - amp2 ) / (s*s);
                                        							}
 													}
	}
	else
	{
	chitable = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <  grid_y ; u += 2 )
			{
			if ( PHASELESS && ( (int)(SigF_1[w][v][u]) < 0 ) )
			{

					s  = fabs(SigF_1[w][v][u]);
					ac = PriorA_1[w][v][u];
					bc = PriorA_1[w][v][u+1];
					ao = Fobs_1[w][v][u];
					bo = Fobs_1[w][v][u+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] = ( amp1 - amp2 ) * ( amp1 - amp2 ) / (s*s);
			}
			else

				if ( (int)(SigF_1[w][v][u]) != 0 )		/* Calculate chi**2 independently for two orthogonal */
					{					/* axis aligned with the Fo vector */

					s   = SigF_1[w][v][u];			/* This is sigma along Fo */
					sph = SigF_1[w][v][u+1];		/* and this is perpendicular to it */
					
					ac = PriorA_1[w][v][u];			/* real and imaginary components of prior */
					bc = PriorA_1[w][v][u+1];
					
					ao = Fobs_1[w][v][u];			/* and Fo */
					bo = Fobs_1[w][v][u+1];
					
					pho = atan2( bo, ao ); 			/* their phases */
					phc = atan2( bc, ac );
										/* and phase difference */
					phdif = acos( cos( pho - phc ));	/* take care of 2PI periodicity */
					phase_diff += phdif;
					
					amp1 = sqrt( ac*ac + bc*bc );		/* Finally, amplitudes */
					amp2 = sqrt( ao*ao + bo*bo );	
					
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] += (amp2 - amp1*cos(phdif))*(amp2 - amp1*cos(phdif)) / (s*s) 
								+ ( amp1*sin(phdif)*amp1*sin(phdif) ) / (sph*sph);
                                        							}
 													}
	
	}
	}







	/**************************************************************************************************************************/
	/**   Calculate chi**2 & update FT(prior)                                                                                **/
	/**************************************************************************************************************************/
	if ( HAVE_FOM == NO )
	{
	sum1 = 0.0;
	sum2 = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
		{
			if ( (int)(SigF[index]) != 0 )
				{
					s  = SigF[index];
					s *= s;
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));
					PriorA[index]   = ( ao - ac ) / s;
					PriorA[index+1] = ( bo - bc ) / s;
                                        							}
			else
				{
					PriorA[index] 	= 0.0;
					PriorA[index+1] = 0.0;
									}

 													}
	}
	else
	{
	sum1 = 0.0;
	sum2 = 0.0;
	phase_diff = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
		{
			if ( PHASELESS && (int)(SigF[index]) < 0 )
			{

					s   = fabs(SigF[index]);
					s  *= s;
					sph = SigF[index+1];
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));

					if ( cycle )
						{
							ao = ac * amp2 / amp1;
							bo = bc * amp2 / amp1;
										}
							
					PriorA[index]   =  sph * ( ao - ac ) / s;  		/* We use the figure of merit to adjust */
					PriorA[index+1] =  sph * ( bo - bc ) / s;	     	/* how quickly we move towards |F| */

			}
			else
			if ( (int)(SigF[index]) != 0 )
				{
										/* Calculate chi**2 independently for two orthogonal */
										/* axis aligned with the Fo vector */

					s   = SigF[index];			/* This is sigma along Fo */
					sph = SigF[index+1];			/* and this is perpendicular to it */
					ac = PriorA[index];			/* real and imaginary components of prior */
					bc = PriorA[index+1];
					ao = Fobs[index];			/* and Fo */
					bo = Fobs[index+1];
					pho = atan2( bo, ao ); 			/* their phases */
					phc = atan2( bc, ac );
										/* and phase difference */
					phdif = acos( cos( pho - phc ));	/* take care of 2PI periodicity */
					phase_diff += phdif;
					
					amp1 = sqrt( ac*ac + bc*bc );		/* Finally, amplitudes */
					amp2 = sqrt( ao*ao + bo*bo );	
					
					sum1 += (amp2 - amp1*cos(phdif))*(amp2 - amp1*cos(phdif)) / (s*s);
					sum1 += ( amp1*sin(phdif)*amp1*sin(phdif) ) / (sph*sph);
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));

					sig1 = fabs(s*cos(pho)) + fabs(sph*sin(pho));
					sig2 = fabs(s*sin(pho)) + fabs(sph*cos(pho));
					sig1 *= sig1;
					sig2 *= sig2;
					if ( sig1 < 1.0 )
						sig1 = 1.0;
					if ( sig2 < 1.0 )
						sig2 = 1.0;
					
					PriorA[index]   = ( ao - ac ) /  sig1;
					PriorA[index+1] = ( bo - bc ) /  sig2;
					
                                        							}
			else
				{
					PriorA[index]   = 0.0;
					PriorA[index+1] = 0.0;
									}

 													}
	
	}






	/**************************************************************************************************************************/
	/**   Info													          */
	/**************************************************************************************************************************/


        if ( verbose == YES )
		{
		if ( SHOW_ENTROPY == NO )
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs) );
		}
		else
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs), ent );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs), ent );
		
		}
		}


	if ( verbose == NO && cycle%VERB_INTERVAL == 0 && WILL_TEST == NO )
		{
		if ( SHOW_ENTROPY == NO )
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs) );
		}
		else
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs), ent );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs), ent );
		
		}
		}
	
	



	
	




	/*********************************************************************************************************************************/
	/**  A quick death														**/
	/*********************************************************************************************************************************/

	if ( cycle == 0 && (( TARGET_CHI > 0.0 && sum1 < TARGET_CHI ) || (TARGET_CHI < 0.0 && sum1 <= nof_obs )))
		{
			printf("\n\n\n\n\n\n\n\n\nThe input data are consistent with a uniform map.\n\n\n");
			exit(1);
					}





	/**************************************************************************************************************************/
	/**   Save current prior so that we can go back if iteration gets out of control				          */
	/**************************************************************************************************************************/

	if ( cycle > 2 && sum1 < chi_p )
		{
			backup_chi = chi_p;
			for ( index = 0 ; index < gridprod ; index++ )
				Back[index] = PriorB[index];
					}

  




	/*********************************************************************************************************************************/
	/**  Switching to phaseless mode. Unfortunately, we have to reload everything on the Fobs and sigma arrays			**/
	/*********************************************************************************************************************************/


	if ( SWITCH > 0.0 && HAVE_FOM && (sum2/sumFo) <= SWITCH && WILL_TEST == NO )
	{
	int i;
	

	SWITCH = -1.0;
	PHASELESS = YES;
	FALSE_ALARM = YES;
	


	
	printf("\n Switching to phaseless mode ...\n");




	/* Repeating code I'm afraid ... */
	
	for ( i=0 ; i < total_number_of_obs ; i++ )
		{
										
			A = refl[i][3] * cos ( PI * refl[i][5] / 180.0 );	/* Real and imaginary */
			B = refl[i][3] * sin ( PI * refl[i][5] / 180.0 );
			w = refl[i][ iuvw[2] -1 ];				/* u,v,w are the coordinates of the reflection */ 
			v = refl[i][ iuvw[1] -1 ];				/* in the FFT array */
			u = 2*refl[i][ iuvw[0] -1 ] +1;
			
			if ( v < 0 )						/* The data structure for FFTW is described in its */
				v = grid_x + v;					/* manual, but the general idea is very similar to */
			if ( w < 0 )						/* the one seen in NR */
				w = grid_z + w;
			v++;
			w++;
			
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			if ( refl[i][4] > 1.0 )
				SigF_1[w][v][u]     = -refl[i][4];
			else
				SigF_1[w][v][u] = -1.0;				/* We will use fom to adjust speed of convergence */
			SigF_1[w][v][u+1]   = refl[i][6];
			}



	sum1 = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
			{

					s   = fabs(SigF[index]);
					s  *= s;
					sph = SigF[index+1];
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));
						}

	for ( index = 0 ; index < gridprod ; index++ )
		{
			PriorA[index] = Back[index];
			PriorB[index] = Back[index];
							}

							

	chi_p = sum1;
	backup_chi = sum1;
	cycle = 0;


	}
	else
	{






	/**************************************************************************************************************************/
	/**   Take transform of it, normalise, multiply with lambda, exponentiate, multiply with prior				 **/
	/**************************************************************************************************************************/
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
	for ( index = 0 ; index < gridprod ; index++ )
              	PriorA[index] *= norm;


	for ( index = 0 ; index < gridprod ; index++ )
		{
			val = PriorA[index];
			PriorA[index] = PriorB[index] * exp(lambda * val);
											}






	/**************************************************************************************************************************/
	/**   This is for the case we run maxent() in order to determine a suitable initial lambda value		         **/
	/**************************************************************************************************************************/
	if ( WILL_TEST == YES )
		{
			if ( chi_p == 0.0 )
				;
			else
				{
					d_chi = chi_p - sum1;
					if ( d_chi < 0.0 )
						{
						free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						return( d_chi );
						}
					else
						if ( cycle > 3 || d_chi == 0.0)
						{
						free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						return( 1.0 );
						}
									}
										}
										














	/**************************************************************************************************************************/
	/**   Reach target ? If not update d_chi for determining next lambda                                                     **/
	/**************************************************************************************************************************/
	if ( TARGET_CHI > 0.0 )
		{
			if ( sum1 < TARGET_CHI )
				{
        				converged = YES;
					break;
							}
								}
	else	
	if ( sum1 < (nof_obs) )
		{
        		converged = YES;
			break;
						}


	if ( HAVE_TIME > 0 && cycle%VERB_INTERVAL == 0 )
		{
			ttest = time(NULL);
			if ( (ttest - tstart) > HAVE_TIME )
				{
					printf("\n\n\n\n\n\n\n Timed-out (keyword TIME). Exit.\n\n");
					converged = YES;
					break;
						}
							}
							



	if ( chi_p == 0.0 )
		;
	else
		d_chi = chi_p - sum1;
	

	if ( d_chi == 0.0  )		
		{
			printf("\n\n\n\n\n\n  Failed to reach convergence. Run the program again with\n");
			printf("  a different starting value for lambda (keyword LAMBDA).\n\n\n\n"); 
			converged = NO;
			break;
					}


/*
	if ( FALSE_ALARM == YES && d_chi > 0.0 )
		FALSE_ALARM = NO;
*/

	cycle++;





	/*********************************************************************************************************************************/
	/**  The iteration get out of control. Go back and decrease lambda								**/
	/*********************************************************************************************************************************/

	if (  d_chi < 0.0 )
		{
		
						/* This can not happen in the automatic lambda determination mode (hopefully). */
		if ( cycle < 4 && FALSE_ALARM == NO )
			{
				printf("\n\n\nThe starting value of lambda is too large. Reduce and re-run.\n\n\n");
				exit(1);
						}

		if ( FALSE_ALARM == YES )
			{
				cycle  = 0;
						}
			


		/*****************************************************************************************************************/
		/**    Go back                                                                                                  **/
		/*****************************************************************************************************************/
		for ( index = 0 ; index < gridprod ; index++ )
			{
				val = Back[index];
	       	      		PriorA[index] = val;
       		      		PriorB[index] = val;

						}
					
		if ( con_lambda == YES )
			lambda *= (double)(0.900000);
		else
			{
				con_lambda = YES;
				lambda *= (double)(0.900000);
							}


	        if ( verbose == YES )
			printf(" *** "); 		


		chi_p = backup_chi;

						}

	else
	{
	/**************************************************************************************************************************/
	/**    Copy new prior.                                                                                                   **/
	/**************************************************************************************************************************/
	for ( index = 0 ; index < gridprod ; index++ )
              	PriorB[index] = PriorA[index];

	chi_p = sum1;
	}
	
	
									}
	

        	 								}


	if ( DO_PLOT == YES && WILL_TEST == NO && converged == YES )
		{
		if ( GRAPH_WAIT == YES )
			printf("\n");
		sprintf( pgtitle, "Maxent map, Cycle %d", cycle );
		plot_section( pgtitle, PriorA_1, grid_z, grid_x, grid_y);
		}


	tend = time(NULL);
	printf("\n\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d \n", 
							sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
	printf(" %d cycles in %d seconds, giving an average of %5.3f seconds per cycle.\n", cycle, (tend-tstart), 
				(float)(tend-tstart)/cycle );


	free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
	free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );

	return( (converged==YES)?(sum2/sumFo):(-(sum2/sumFo)) );

}































































































/*********************************************************************************************************************************/
/** Write out the map in one of the three available formats : ASCII, NA4, CCP4						 	**/
/*********************************************************************************************************************************/

void	write_map( title, data, slow, med, fast, iuvw, mode, details )
char	*title[];
float	***data;
int	iuvw[3];
int	slow;
int	med;
int	fast;
int	mode;
char 	*details;
{
	FILE	*file;
	int	u, v, w;
	float	val;
	int	x, y, z;
	float	min, max, mean, rms;
	float	scale, plus;
	int	m;
	int	INDXR4_1, INDXR4_2;
	int	I, J, N;
	float	A, P;
	char 	string[4];
	int	mxyz[3];
	char	ntitle[82];
	float	sum, ent;






	for ( m = 0 ; m <= strlen( &details[0] ) ; m++ )
		if ( details[m] == '\n' )
			details[m] = 0;



	/*********************************************************************************************************************************/
	/**  Calculate map statistics, scale to a maximum of 999									**/
	/*********************************************************************************************************************************/
			

        max  = data[1][1][1];
	mean = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		{
		val = data[w][v][u];
                if ( val > max )
			max = val;
		mean += val;
				}
	printf(" - Sum and average of densities are %12.4f and %12.4f.\n", mean, mean / (slow*med*fast) );
	

	scale = 999.0 / max;
	printf(" - Scale factor applied : %15.8f.\n", scale );
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		data[w][v][u] *= scale;		
		


        min  = data[1][1][1];
        max  = min;
        mean = 0.0;
        rms  = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
                        if ( val > max )
                                max = val;
                        if ( val < min )
                                min = val;
                        mean += val;
                                                }
        mean /= (float)(slow*med*fast);

        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
			rms += ( val - mean ) * ( val - mean );
				}
        rms = (float)(sqrt( rms / (double)(slow*med*fast - 1.0)));





	/*********************************************************************************************************************************/
	/**  Calculate relative entropy of map 												**/
	/*********************************************************************************************************************************/

	if ( min >= 0.0000 )
	{
	sum = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		sum += 	data[w][v][u];

	ent = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
			ent += -( val / sum ) * log( val / sum );
				}
	printf(" - Map entropy is %f.\n", ent );
	}
	else
		printf(" - Map entropy is undefined (negative values are present).\n");
		
			
	/*********************************************************************************************************************************/
	/**  NA4 format.														**/
	/*********************************************************************************************************************************/


	if ( MAP_FORMAT == NA4_MAP )
	{

	/* Re-writing FORTRAN ... */
	

	A = max2( fabs(min), fabs(max));
	P = 24.0 - log( A ) / log( 2.0 );
	if ( P < 0.0 )
		I = P - 1;
	else
		I = P;
	
	if ( I == 0 )
		N = A;
	else
		if ( I == 1 )
			N = 2 * A;
		else
			N = A * ( 2 << (I-1));
	
	if ( N < (2 << 22)) 
		I = I + 1;
	else
	if ( N > (2 << 23))
		I = I - 1;
		

	N = 0;
	if ( min < 0.0 )
		N = N - 1;
	else
		if ( min > 0.0 )
			N = N + 1;
	if ( max < 0.0 )
		N = N - 1;
	else
		if ( max > 0.0 )
			N = N + 1;
		
	INDXR4_1 = N;
	if ( N == 0 )
		INDXR4_2 = I - 1;
	else
		INDXR4_2 = I;
	
	


	file = fopen( title[0], "w" );
	if ( file == NULL )
		{
			fclose ( file );
			printf("Failed to create the output map file.\n\n\n");
			exit( 0 );
						}


	if ( iuvw[0] == 1 )
		x = fast;
	if ( iuvw[0] == 2 )
		y = fast;
	if ( iuvw[0] == 3 )
		z = fast;
	if ( iuvw[1] == 1 )
		x = med;
	if ( iuvw[1] == 2 )
		y = med;
	if ( iuvw[1] == 3 )
		z = med;
	if ( iuvw[2] == 1 )
		x = slow;
	if ( iuvw[2] == 2 )
		y = slow;
	if ( iuvw[2] == 3 )
		z = slow;


	fprintf(file, "MAPTONA4 HEADER\n");
	fprintf(file, "TITLE   \n");
	fprintf(file, "%s\n", &details[0]);
	fprintf(file, "AXIS           %c       %c       %c\n", 'X'+iuvw[0]-1, 'X'+iuvw[1]-1, 'X'+iuvw[2]-1 );
	fprintf(file, "GRID       % 5d   % 5d   % 5d\n", x, y, z);
	fprintf(file, "XYZLIM         0   % 5d       0   % 5d       0   % 5d\n", x-1, y-1, z-1);
	fprintf(file, "SPACEGROUP          % 4d\n",spacegroup);
	fprintf(file, "MODE           %d\n", mode);
	fprintf(file, "CELL    % 10.3f% 10.3f% 10.3f% 10.3f% 10.3f% 10.3f\n",cell[0],cell[1],cell[2],cell[3],cell[4],cell[5]);
	fprintf(file, "RHOLIM% 16.6f% 16.6f% 16.6f% 16.6f\n", min, max, mean, rms);
	fprintf(file, "INDXR4  % 4d% 4d\n", INDXR4_1, INDXR4_2);
	fprintf(file, "END HEADER\n");


        for ( w=1 ; w <= slow ; w++ )
	{
	fprintf( file , "\nSECTION% 8d\n\n", w-1 );
	
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u += 20 )
                {
			for ( m=u ; m < ( fast < (u+20) ? fast+1 : u+20 ) ; m++ )
				{
				tona4( &string[0], data[w][v][m], INDXR4_1, INDXR4_2);
				fprintf(file,"%c%c%c%c", string[0], string[1], string[2], string[3]);
				}
			fprintf(file, "\n");
					}
						}
						
			
			
			



	fclose(file);

	}
	else


	/*********************************************************************************************************************************/
	/**  ASCII map 															**/
	/*********************************************************************************************************************************/
	if ( MAP_FORMAT == ASCII_MAP )
	{
	
	file = fopen( title[0], "w" );
	if ( file == NULL )
		{
			fclose ( file );
			printf("Failed to create the output map file.\n\n\n");
			exit( 0 );
						}
	
	for ( w = 1; w <= slow ; w++ )
	{
	fprintf(file, "\n");
	for ( v = 1; v <= med  ; v++ )
	{
	fprintf(file, "\n");
	for ( u = 1; u <= fast ; u++ )
		fprintf(file, " % 8.3f", data[w][v][u] );
							}
								}
	printf("\n");
	fclose(file);
	}
	else



	/*********************************************************************************************************************************/
	/**  Binary CCP4 														**/
	/*********************************************************************************************************************************/
	if ( MAP_FORMAT == CCP4_MAP )
	{
#ifndef NOCCP4	
	int 	unit, ist;
	int	nw1, nu1, nu2, nv1, nv2;
	float	***inter;
	
	


	if ( iuvw[0] == 1 )
		x = fast;
	if ( iuvw[0] == 2 )
		y = fast;
	if ( iuvw[0] == 3 )
		z = fast;
	if ( iuvw[1] == 1 )
		x = med;
	if ( iuvw[1] == 2 )
		y = med;
	if ( iuvw[1] == 3 )
		z = med;
	if ( iuvw[2] == 1 )
		x = slow;
	if ( iuvw[2] == 2 )
		y = slow;
	if ( iuvw[2] == 3 )
		z = slow;	
		
	unit = 1;
	ist  = 24;
	mxyz[0] = x;
	mxyz[1] = y;
	mxyz[2] = z;
	nw1 = 0;
	nu1 = 0;
	nu2 = fast-1;
	nv1 = 0;
	nv2 = med-1;

	strncpy( &ntitle[0], &details[0], 80 );
	                      
	mwrhdl_( &unit, title[0], ntitle, &slow, &iuvw[0], &mxyz[0], &nw1, &nu1, &nu2, &nv1, &nv2, &cell[0], 
			&spacegroup, &mode, strlen( title[0] ), 80 );
	msyput_( &ist, &spacegroup, &unit );
	inter = f3tensor( 1, 1, 1, med, 1, fast );
	for ( w = 1; w <= slow ; w++ )
		{
	        for ( v=1 ; v <= med  ; v++ )
	        for ( u=1 ; u <= fast ; u++ )
		inter[1][v][u] = data[w][v][u];

		mspew_( &unit, &inter[1][1][1] );
			}
	
	free_f3tensor( inter,  1, 1, 1, med, 1, fast );
	
	mwclose_( &unit );
	
#endif
	}

}











/*********************************************************************************************************************************/
/** Oops														 	**/
/*********************************************************************************************************************************/	

void 	abortp()
{

        printf("\n\n\nUsage :   GraphEnt [<ascii file name>]\n");
        printf("          GraphEnt [h0l | 0kl | hk0] [<low_res> <high_res>] <CCP4 mtz file>\n\n\n\n");
	exit(1);
}








	/*********************************************************************************************************************************/
	/**  	**/
	/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/** Hmm...														 	**/
/*********************************************************************************************************************************/

void 	extram()
{

	printf("    Note well (i) : The axes permutation must be chosen in such a way   \n");
	printf("   		    that the fast index is always positive or zero.     \n");
	printf("                    To avoid problems, use the CCP4 convention (as      \n");
	printf("		    described below) with PERM 3 1 2 or 3 2 1.          \n");
	printf("    Note well (ii): If you expanded the data to P1 (using CAD ?), then  \n");
	printf("                    reflections that belong to the same hemisphere but  \n");
	printf("                    related by the inverion centre will, naturally, be  \n");
	printf(" 		    absent. The program needs these reflections and     \n");
	printf("  		    will generate them if they are not present. The 	 \n");
	printf("		    convention assumed is the same as for CCP4, namely  \n");
	printf("		    hkl : l>=0,      hk0 : h>=0,       0k0 : k>=0       \n");
	
	
	printf("\n\n\n\n\n");
}


















/* I'm so confused about what is doing what at this stage, that I feel like writing four pages of comments. */
/* So, the story is that when we are given foms, we can no longer stick to a symmetric Gaussian centered on the Fobs vector.*/
/* My first attempt was to treat independently the amplitude and phase of the sf (in which case the Gaussian approximation is */
/* still valid). The trouble was that there was no obvious way to adjust the convergence and relative contribution of the phase*/
/* terms compared with the amplitude terms (plus that due to the 2PI periodicity, the chi**2 on phases playes little role on the*/
/* total chi**2, and that you can't keep the phases from converging much quicker than the amplitudes which leads to underestimating*/
/* the phase error). My second attempt is to approximate the locus (that represents the sf pdf) */
/* with a 2D Gaussian (with independent and B components) which `spins` together */
/* with the input Fobs vector. That means that the axes of the Gaussian ellipsoid rotate */
/* freely with respect to the standard orthogonal setting. The trouble with this approach was that it would take for ever to */
/* calculate an acceptable 2D Gaussian approximation to the observed pdf. So, this took us one step further : the parameters of the*/
/* sought 2D Gaussian depend only on F,sigF and fom. The chosen solution was to compile a large matrix containing the sought parameters*/
/* for a large enough set of combinations of F/sigF and fom. This list goes from 			*/
/*          fom    :   0.000 to      0.999900 in steps of  0.010 (except for last)			*/
/*  and  F/sigF    :   0.010 to   655.5360 in steps of powers of SQRT(2)				*/
/* giving a total of ???? lines containing for each combination of F/sigF and fom, the values of A,sigA,sigB (B is 0.0 since the */
/* axes of the ellipsoid are aligned with Fobs). What is happening then is the following : the main() passes us the value of */
/* F, sigF and fom for a given reflection. We calculate F/sigF and check that both this and fom are within bounds. If they are not,*/
/* we write-out an info message (if verbose) and reset it to lie inside range. Then, if we are safely inside the matrix region, we use*/
/* interpolation using a maximum of 4 points (ie a 3rd order polynomial). If we are on the edge, we simply take care not to include */
/* things that are not there. Once we have values for A, sigA, sigB, we multiply with F and return.*/



void	get_param( F, sigF, fom, A, sigA, sigB )
float	F;
float	sigF;
float	fom;
float	*A, *sigA, *sigB;
{

	float	FsigF;
	float	x[4], y[4];			/* Vectors for interpolations */
	int 	fom_offset_1;			/* fom and FsigF values from table enclosing target value */
	int 	fom_offset_2;
	int 	fom_offset_3;
	int 	fom_offset_4;
	int	F_offset_1;
	int	F_offset_2;
	int	F_offset_3;
	int	F_offset_4;
	float	a1, a2, a3, a4, junk;
	float	f1, f2, f3, f4;			/* These are the F/sigF matrix values surrounding the target value */
	float	fom1, fom2, fom3, fom4;		/* These are the fom    matrix values surrounding the target value */
	int	power;
	
	
	FsigF = F / sigF;
	if ( FsigF < 0.01000 )
		{
			if ( verbose == YES )
				printf(" Reflection with F/sigF less than 0.010. Reset.\n");
			FsigF = 0.010000010;
				}
	if ( FsigF >= (2<<14)*SQRT2*0.010000 )
		{
			if ( verbose == YES )
				printf(" Reflection with F/sigF greater than 463.4. Reset.\n");
			FsigF = (2<<14)*SQRT2*0.010000-0.000000100;
				}
	if ( fom > 0.999900000 )
		{
			if ( verbose == YES )
				printf(" Reflection with fom greater than 0.99990. Adjusted to 0.99990.\n");
			fom = 0.999899999999999;
				}




	/********************************************************************************************************/
	/*			Real Programmers like Arithmetic IF Statements - they make the			*/
	/*			code more interesting.								*/
	/*													*/
	/*  							From 'Real Programmers Don't Write Pascal'	*/
	/* ps. Not only real programmers									*/
	/********************************************************************************************************/


	
						
									/* This is the table offset to get to low boundary of fom */
	if ( (int)(fom*100.00) == 0 )
	{
	fom1 = 0.00000000;
	fom2 = 0.01000000;
	fom3 = 0.02000000;
	fom4 = 0.03000000;
	fom_offset_1 = 0;
	fom_offset_2 = 1;
	fom_offset_3 = 2;
	fom_offset_4 = 3;
	}
	else if ( (int)(fom*100.00) == 99 || (int)(fom*100.00) == 98 )
	{
	fom1 = 0.97000000;
	fom2 = 0.98000000;
	fom3 = 0.99000000;
	fom4 = 0.99990000;
	fom_offset_1 = 97;
	fom_offset_2 = 98;
	fom_offset_3 = 99;
	fom_offset_4 = 100;
	}
	else
	{
	fom1 = 0.01000000*((int)(fom*100.00)-1);
	fom2 = 0.01000000*(int)(fom*100.00);
	fom3 = 0.01000000*((int)(fom*100.00)+1);
	fom4 = 0.01000000*((int)(fom*100.00)+2);
	fom_offset_1 = (int)(fom*100.00)-1;
	fom_offset_2 = (int)(fom*100.00);
	fom_offset_3 = (int)(fom*100.00)+1;
	fom_offset_4 = (int)(fom*100.00)+2;
	}
	
	
									/* This is the power of SQRT2 that take us to low bound*/
	power = (int)( (log10((double)(FsigF/0.0100000))/log10(SQRT2)) );
	
	
	
	if ( power == 0 )						/* Low end of table */
	{
	f1 = GETTABLEVAL(power);
	f2 = GETTABLEVAL(power+1);
	f3 = GETTABLEVAL(power+2);
	f4 = GETTABLEVAL(power+3);
	F_offset_1 = 0;
	F_offset_2 = 101;
	F_offset_3 = 202;
	F_offset_4 = 303;
	}
	else if ( power == 30 )						/* High end of table */
	{
	f1 = GETTABLEVAL(power-2);
	f2 = GETTABLEVAL(power-1);
	f3 = GETTABLEVAL(power);
	f4 = GETTABLEVAL(power+1);
	F_offset_1 = 2828;
	F_offset_2 = 2929;
	F_offset_3 = 3030;
	F_offset_4 = 3131;
	}
	else								/* Normal */
	{
	f1 = GETTABLEVAL(power-1);
	f2 = GETTABLEVAL(power);
	f3 = GETTABLEVAL(power+1);
	f4 = GETTABLEVAL(power+2);
	F_offset_1 = 101*(power-1);
	F_offset_2 = 101*(power  );
	F_offset_3 = 101*(power+1);
	F_offset_4 = 101*(power+2);
	}
	
	
	
	/* We now know where we are. Start loading interpolation vectors and doing the calculation for the three parameters */
	
	/* A */
	/* You are not going to believe this ... */
	
	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_1 + fom_offset_1][0];
	y[1] = pdf2Gauss[ F_offset_1 + fom_offset_2][0];
	y[2] = pdf2Gauss[ F_offset_1 + fom_offset_3][0];
	y[3] = pdf2Gauss[ F_offset_1 + fom_offset_4][0];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a1, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_2 + fom_offset_1][0];
	y[1] = pdf2Gauss[ F_offset_2 + fom_offset_2][0];
	y[2] = pdf2Gauss[ F_offset_2 + fom_offset_3][0];
	y[3] = pdf2Gauss[ F_offset_2 + fom_offset_4][0];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a2, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_3 + fom_offset_1][0];
	y[1] = pdf2Gauss[ F_offset_3 + fom_offset_2][0];
	y[2] = pdf2Gauss[ F_offset_3 + fom_offset_3][0];
	y[3] = pdf2Gauss[ F_offset_3 + fom_offset_4][0];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a3, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_4 + fom_offset_1][0];
	y[1] = pdf2Gauss[ F_offset_4 + fom_offset_2][0];
	y[2] = pdf2Gauss[ F_offset_4 + fom_offset_3][0];
	y[3] = pdf2Gauss[ F_offset_4 + fom_offset_4][0];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a4, &junk);

	
	/* Get it */
	x[0] = f1;
	x[1] = f2;
	x[2] = f3;
	x[3] = f4;
	y[0] = a1;
	y[1] = a2;
	y[2] = a3;
	y[3] = a4;
	polint( &x[0]-1, &y[0]-1, 4, FsigF, A, &junk);	
	
	
	
	
	/* sigA */
	
	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_1 + fom_offset_1][1];
	y[1] = pdf2Gauss[ F_offset_1 + fom_offset_2][1];
	y[2] = pdf2Gauss[ F_offset_1 + fom_offset_3][1];
	y[3] = pdf2Gauss[ F_offset_1 + fom_offset_4][1];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a1, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_2 + fom_offset_1][1];
	y[1] = pdf2Gauss[ F_offset_2 + fom_offset_2][1];
	y[2] = pdf2Gauss[ F_offset_2 + fom_offset_3][1];
	y[3] = pdf2Gauss[ F_offset_2 + fom_offset_4][1];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a2, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_3 + fom_offset_1][1];
	y[1] = pdf2Gauss[ F_offset_3 + fom_offset_2][1];
	y[2] = pdf2Gauss[ F_offset_3 + fom_offset_3][1];
	y[3] = pdf2Gauss[ F_offset_3 + fom_offset_4][1];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a3, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_4 + fom_offset_1][1];
	y[1] = pdf2Gauss[ F_offset_4 + fom_offset_2][1];
	y[2] = pdf2Gauss[ F_offset_4 + fom_offset_3][1];
	y[3] = pdf2Gauss[ F_offset_4 + fom_offset_4][1];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a4, &junk);

	
	/* Get it */
	x[0] = f1;
	x[1] = f2;
	x[2] = f3;
	x[3] = f4;
	y[0] = a1;
	y[1] = a2;
	y[2] = a3;
	y[3] = a4;
	polint( &x[0]-1, &y[0]-1, 4, FsigF, sigA, &junk);	
	
	
	
	
	/* B */
	
	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_1 + fom_offset_1][2];
	y[1] = pdf2Gauss[ F_offset_1 + fom_offset_2][2];
	y[2] = pdf2Gauss[ F_offset_1 + fom_offset_3][2];
	y[3] = pdf2Gauss[ F_offset_1 + fom_offset_4][2];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a1, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_2 + fom_offset_1][2];
	y[1] = pdf2Gauss[ F_offset_2 + fom_offset_2][2];
	y[2] = pdf2Gauss[ F_offset_2 + fom_offset_3][2];
	y[3] = pdf2Gauss[ F_offset_2 + fom_offset_4][2];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a2, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_3 + fom_offset_1][2];
	y[1] = pdf2Gauss[ F_offset_3 + fom_offset_2][2];
	y[2] = pdf2Gauss[ F_offset_3 + fom_offset_3][2];
	y[3] = pdf2Gauss[ F_offset_3 + fom_offset_4][2];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a3, &junk);

	x[0] = fom1;
	x[1] = fom2;
	x[2] = fom3;
	x[3] = fom4;
	y[0] = pdf2Gauss[ F_offset_4 + fom_offset_1][2];
	y[1] = pdf2Gauss[ F_offset_4 + fom_offset_2][2];
	y[2] = pdf2Gauss[ F_offset_4 + fom_offset_3][2];
	y[3] = pdf2Gauss[ F_offset_4 + fom_offset_4][2];
	polint( &x[0]-1, &y[0]-1, 4, fom, &a4, &junk);

	
	/* Get it */
	x[0] = f1;
	x[1] = f2;
	x[2] = f3;
	x[3] = f4;
	y[0] = a1;
	y[1] = a2;
	y[2] = a3;
	y[3] = a4;
	polint( &x[0]-1, &y[0]-1, 4, FsigF, sigB, &junk);	
	
	
	
	
	
	
}



	
	
void polint(float xa[], float ya[], int n, float x, float *y, float *dy)
{
	float	x1, x2, x3, x4;
	float	y1, y2, y3, y4;
	
	x1 = xa[1];
	x2 = xa[2];
	x3 = xa[3];
	x4 = xa[4];

	y1 = ya[1];
	y2 = ya[2];
	y3 = ya[3];
	y4 = ya[4];
	
	*y = y1*(x-x2)*(x-x3)*(x-x4) / ( (x1-x2)*(x1-x3)*(x1-x4) ) +
	     y2*(x-x1)*(x-x3)*(x-x4) / ( (x2-x1)*(x2-x3)*(x2-x4) ) +
	     y3*(x-x1)*(x-x2)*(x-x4) / ( (x3-x1)*(x3-x2)*(x3-x4) ) +
	     y4*(x-x1)*(x-x2)*(x-x3) / ( (x4-x1)*(x4-x2)*(x4-x3) );

}











/* Re-writing FORTRAN : routine from maptona4 (Phil Evans), originally due to Ian Tickle, Birkbeck. */

void tona4( string, val, INDXR4_1, INDXR4_2)
char 	*string;
float	val;
int	INDXR4_1, INDXR4_2;
{

	int 	I, J, M, N;
	const char	CHRTAB[65] = "0123456789-+ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	
	
	if ( val == 0.0 )
		strncpy( string, "0000", 4);
	
	else
		{
			if ( INDXR4_2 == 0 )
				N = nearint( fabs(val) );
			else
			if ( INDXR4_2 == 1 )
				N = nearint( 2 * fabs(val) );
			else
				N = nearint( fabs(val) * ( 2 << (INDXR4_2-1)) );
			
			if ( INDXR4_1 == 0 )
				M = 2 << 22;
			else
				M = 2 << 23;
			
			if ( N == M )
				N = M - 1;
			else
			if ( N > M )
				{
				strncpy( string, "****", 4);
				return;
				}
			
			if ( INDXR4_1 == 0 && val < 0.0 )
				N = ( 2 << 23 ) - N;
			
			for ( I=4 ; I >= 1 ; I-- )
				{
					M = N / 64;
					J = N - 64*M;
					string[I-1] = CHRTAB[J];
					N = M;
						}
							}
	return;
}






void	plot_section( title, data, slow, med, fast)
char	*title;
float	***data;
int	slow;
int	med;
int	fast;
{
	int	u, v, w;
	float	val;
	int	x, y, z;
	int 	i, j, k, lw, ci, ls;
	float	min, max, mean, rms;
	float	scale, plus;
	int	m;
	float	alev;
	float	j1, j2, j3, j4;
	float	***inter;
	int	nof_contours;



	if ( HAVE_PGPLOT == NO )
		return;
	


#ifndef NOPGPLOT
	inter = f3tensor( 1, 1, 1, med, 1, fast );
	
	w = GRAPH_SECTION;
	
        mean = 0.0;
        rms  = 0.0;
	max  = data[w][1][1];
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
           	{
			val = data[w][v][u];
                        if ( val > max )
                                max = val;
			mean += val;
				}
				
        mean /= (float)(med*fast);

        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
			rms += ( val - mean ) * ( val - mean );
								}

        rms = (float)(sqrt( rms / (double)(med*fast - 1.0)));

	nof_contours = (int)(((max-mean) / rms) / CONTOUR_LEVEL) +1;
	
	
	cpgpage();

	cpgqvsz(1, &j1, &j2, &j3, &j4 );
	if (  (j4/j2) > aspect )
		{
			cpgsvp( 0.0 , 1.0 , 0.0 , aspect / (j4/j2)  );
		}
	else
		{
			cpgsvp( 0.0 , (j4/j2) / aspect, 0.0 , 0.95 );
		}
		



	cpgbox("bcts", (xmax-xmin)/2.0, 2, "bcts", (ymax-ymin)/2.0, 2);
	cpgmtxt("t", 1.0, 0.0, 0.0, title);

	for ( v=1 ; v <= med  ; v++ )
	for ( u=1 ; u <= fast ; u++ )
		inter[1][v][u] = data[w][v][u];

	if ( GRAYSCALE == YES )
		cpggray( &inter[1][1][1], fast, med, 1, fast, 1, med, 4*rms+mean+ rms*FIRST_CONTOUR, mean+ rms*FIRST_CONTOUR, tr);
	
    	for (i=0; i <= nof_contours ; i++) 
		{
		
    		alev = mean + rms*FIRST_CONTOUR + i*rms * CONTOUR_LEVEL;
		if ( alev > max )
			break;
			
    		lw = 1 ;
    		ls = (i==0)?4 :1;
    		cpgslw(lw);
    		cpgsci( i <= 10 ? i + 16 : 26);
    		cpgsls(ls);
    		cpgcont(&inter[1][1][1], fast, med, 1, fast, 1, med, &alev, -1, tr);
		}
  	cpgslw(1);
  	cpgsls(1);
  	cpgsci(1);

	free_f3tensor( inter,  1, 1, 1, med, 1, fast );

#endif

	return;
}
	

















/**********************************************************************************************************************************/
/**   Public domain  memory allocation routines from Numerical recipes.                                                          **/
/**********************************************************************************************************************************/

float *vector(long nl, long nh)
/* allocate a float vector with subscript range v[nl..nh] */
{
        float *v;

        v=(float *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(float)));
        if (!v) nrerror("allocation failure in vector()");
        return v-nl+NR_END;
}


void free_vector(float *v, long nl, long nh)
/* free a float vector allocated with vector() */
{
        free((FREE_ARG) (v+nl-NR_END));
}

void    	nrerror( char error_text[])
{
	printf("\n%s\n", &error_text[0] );
	exit( 1 );
}



float	**matrix( long nrl, long nrh, long ncl, long nch )
{
	long 	i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
	float	**m;

	m = (float **)malloc((size_t)((nrow+NR_END)*sizeof(float*)));
	if (!m) nrerror("allocation failure 1 in matrix()");
	m += NR_END;
	m -= nrl;
	m[nrl] = (float *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(float)));
	if (!m[nrl]) nrerror("allocate failure 2 in matrix()");
	m[nrl] += NR_END;
	m[nrl] -= ncl;

	for (i=nrl+1 ; i <= nrh ; i++ )
		m[i] = m[i-1] + ncol;

	return m;
}


float	***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh )
{
	long 	i, j, nrow=nrh-nrl+1, ncol=nch-ncl+1, ndep = ndh-ndl+1;
	float	***t;

	t=(float ***)malloc((size_t)((nrow+NR_END)*sizeof(float**)));
	if (!t) nrerror("allocation failure 1 in f3tensor()");
	t += NR_END;
	t -= nrl;

	t[nrl] = (float **)malloc((size_t)((nrow*ncol+NR_END)*sizeof(float *)));
	if ( !t[nrl] ) nrerror("allocation failure 2 in f3tensor()");
	t[nrl] += NR_END;
	t[nrl] -= ncl;
	
	t[nrl][ncl] = (float *)malloc((size_t)((nrow*ncol*ndep + NR_END)*sizeof(float)));
	if (!t[nrl][ncl] ) nrerror("allocation failure 3 in f3tensor()");
	t[nrl][ncl] += NR_END;
	t[nrl][ncl] -= ndl;

	for( j=ncl+1 ; j <= nch ; j++ )
		t[nrl][j] = t[nrl][j-1] + ndep;
	for ( i=nrl+1 ; i <= nrh ; i++ )
		{
		t[i] = t[i-1] + ncol;
		t[i][ncl] = t[i-1][ncl] + ncol * ndep;
		for ( j=ncl+1 ; j <= nch ; j++ )
			t[i][j] = t[i][j-1] + ndep;
                                              	}

	return t;
}





void free_matrix(float **m, long nrl, long nrh, long ncl, long nch)
/* free a float matrix allocated by matrix() */
{
        free((FREE_ARG) (m[nrl]+ncl-NR_END));
        free((FREE_ARG) (m+nrl-NR_END));
}


void free_f3tensor(float ***t, long nrl, long nrh, long ncl, long nch,
        long ndl, long ndh)
/* free a float f3tensor allocated by f3tensor() */
{
        free((FREE_ARG) (t[nrl][ncl]+ndl-NR_END));
        free((FREE_ARG) (t[nrl]+ncl-NR_END));
        free((FREE_ARG) (t+nrl-NR_END));
}




















/*********************************************************************************************************************************/
/** Normal probability plot calculation and plotting 									 	**/
/*********************************************************************************************************************************/


void	normprob( in )
FILE 	*in;
{

        char    j[200];
        float   **refl;
        float   *finpp;
	float	*plot1;
	int	saving[MAX_NOF_REFL];
        int     nref;
        int     i, m;
        int     step;
        float   aver_s, aver_df, aver_gof;
        float   v1, v2, v3;
        FILE	*out;
        float   px;
        double  x, y, ylast;
        double  d1;
        float   r1, r2;
        float   bdiv;
        float   sig_mul;
        int     test;

	float	minx, maxx, miny, maxy;



	refl = matrix( 0, 6, 0, MAX_NOF_REFL );
	finpp = vector( 0, MAX_NOF_REFL );
	plot1 = vector( 0, MAX_NOF_REFL );

        m=0;
        for ( x = 0.0 ; x <= 4.095 ; x += 0.0010 )
        {

        y = 1.0;
        ylast = 1.0;
        i = 1;
        while( 1 )
                {
                if ( i % 2 )
                        y -= pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, i) * fact(i) );
                else
                        y += pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, i) * fact(i) );
                                        
                if ( fabs( y - ylast ) < 0.0000000000001 )
                        break;
                i++;
                ylast=y;
                }
        
        y *= 2.0 * x * 0.398942280402;
        normtab[0][m] = x;
        normtab[1][m] = y;

        m++;


        
        }


	rewind(in);
	fgets( j, 299, in );

        nref = 0;
        while ( fscanf( in, "%f %f %f %f %f %f %f"
                ,&refl[4][nref],&refl[5][nref],&refl[6][nref],&refl[0][nref],&refl[1][nref],&refl[2][nref],&refl[3][nref]) == 7 )
		{
			plot1[nref] = (refl[0][nref]-refl[2][nref])/ sqrt( refl[1][nref]*refl[1][nref] + refl[3][nref]*refl[3][nref] );
                        nref++;
				}
				
	for ( i=0 ; i < nref ; i++ )
		saving[i] = i;
		
	if ( nref > 2 )
	{
        unsigned long n, i,ir,j,l;
	float	rra, *ra;
	int	*sav, s1;
	
	ra = &plot1[0] - 1;
	sav = &saving[0] - 1;
	
	n = nref;
        l=(n >> 1)+1;
        ir=n;
        for (;;) {
                if (l > 1) {
                        rra=ra[--l];
			s1 = sav[l];
                } else {
                        rra=ra[ir];
			s1 = sav[ir];
                        ra[ir]=ra[1];
			sav[ir] = sav[1];
                        if (--ir == 1) {
                                ra[1]=rra;
				sav[1] = s1;
                                break;
                        }
                }
                i=l;
                j=l+l;
                while (j <= ir) {
                        if (j < ir && ra[j] < ra[j+1]) j++;
                        if (rra < ra[j]) {
                                ra[i]=ra[j];
				sav[i] = sav[j];
                                i=j;
                                j <<= 1;
                        } else j=ir+1;
                }
                ra[i]=rra;
		sav[i] = s1;
        }
	}
	else
	{
		printf("\n\n\nLess than two reflections (???). Abort.\n\n");
		exit(1);
				}
				


	rewind(in);
	fgets( j, 299, in );

	if ( nref % 2 == 0 )
		{
			for ( i = nref/2 ; i < nref ; i++ )
				{
				plot1[i-1] = plot1[i];
				saving[i-1] = saving[i];
				}

			nref--;
		}			
	
	
        for ( i=1 ; i <= (int)(nref/2)+1 ; i++ )
                {
                        px = ((double)(nref) - 2.0 * i + 1.0) / (double)(nref) ;
                        d1 = (float)(findx( px ));
                        finpp[i-1] = -d1;
                        finpp[nref-i] = d1;
                                                }

#ifdef NOPGPLOT
	out = fopen( "MAXENT_normal_prob_plot.dat", "w");
	for ( i=0 ; i < nref ; i++ )
		fprintf(out, " % 15.5f % 15.5f\n",  finpp[i], plot1[i] );
	fclose(out);
#endif

	out = fopen( "Normplot_tails.dat", "w");
	for ( i=0 ; i < 2*(int)(nref*0.020) ; i++ )
		fprintf(out, " % 5d % 5d % 5d     % +15.5f % +15.5f\n", nearint(refl[4][saving[i]])
			, nearint(refl[5][saving[i]]), nearint(refl[6][saving[i]]), finpp[i], plot1[i] );
	for ( i=nref - 2*(int)(nref*0.020)  ; i < nref ; i++ )
		fprintf(out, " % 5d % 5d % 5d     % +15.5f % +15.5f\n", nearint(refl[4][saving[i]])
			, nearint(refl[5][saving[i]]), nearint(refl[6][saving[i]]), finpp[i], plot1[i] );
	fclose(out);


	



#ifndef NOPGPLOT


	minx = finpp[0];
	maxx = finpp[0];
	miny = plot1[0];
	maxy = plot1[0];
	for ( i=0 ; i < nref ; i++ )
		{
			if ( finpp[i] > maxx )
				maxx = finpp[i];
			if ( finpp[i] < minx )
				minx = finpp[i];
			if ( plot1[i] > maxy )
				maxy = plot1[i];
			if ( plot1[i] < miny )
				miny = plot1[i];
					}
					


	if( cpgopen("/XWIN") <= 0 )
		{
			printf("Can not open X window for plot.\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( -1.0250*max2(fabs(minx),fabs(maxx)), 1.0250*max2(fabs(minx),fabs(maxx)), 
					-1.0250*max2(fabs(miny),fabs(maxy)), 1.0250*max2(fabs(miny),fabs(maxy)) );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
    			cpgsci(2);
			cpgmtxt("t", 1.0, 0.0, 0.0, "Normal probability plot");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < nref ; i++ )
				{
				if ( i < 2*(int)(nref*0.020) || i >= (nref - 2*(int)(nref*0.020)) )
					cpgsci(6);
				else
					cpgsci(3);					
				cpgpt1( (float)(finpp[i]), plot1[i], -2 );
					}
					
			cpgslw(3);
			cpgsls(4);
    			cpgsci(2);
			cpgmove( -max2(fabs(miny),fabs(maxy)), -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( max2(fabs(miny),fabs(maxy)), max2(fabs(miny),fabs(maxy)) );

			cpgslw(1);
			cpgsls(1);
    			cpgsci(1);
			cpgmove( 0, -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( 0,  max2(fabs(miny),fabs(maxy)) );
			cpgmove( -max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgdraw(  max2(fabs(minx),fabs(maxx)), 0.0 );


								}

	if( cpgopen("Normal_probability.ps/cps") <= 0 )
		{
			printf("Can not open postscript file for plot.\n");
			DO_PLOT = NO;
					}
	else
		{

			cpgslw(1);
    			cpgsci(2);
			cpgswin( -1.0250*max2(fabs(minx),fabs(maxx)), 1.0250*max2(fabs(minx),fabs(maxx)), 
					-1.0250*max2(fabs(miny),fabs(maxy)), 1.0250*max2(fabs(miny),fabs(maxy)) );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
    			cpgsci(2);
			cpgmtxt("t", 1.0, 0.0, 0.0, "Normal probability plot");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < nref ; i++ )
				{
				if ( i < 2*(int)(nref*0.020) || i >= (nref - 2*(int)(nref*0.020)) )
					cpgsci(6);
				else
					cpgsci(3);					
				cpgpt1( (float)(finpp[i]), plot1[i], -2 );
					}
			
			cpgslw(3);
			cpgsls(4);
    			cpgsci(2);
			cpgmove( -max2(fabs(miny),fabs(maxy)), -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( max2(fabs(miny),fabs(maxy)), max2(fabs(miny),fabs(maxy)) );

			cpgslw(1);
			cpgsls(1);
    			cpgsci(1);
			cpgmove( 0, -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( 0,  max2(fabs(miny),fabs(maxy)) );
			cpgmove( -max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgdraw(  max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgclos();
						}



#endif	



	free_matrix(refl,  0, 6, 0, MAX_NOF_REFL );
	free_vector(finpp, 0, MAX_NOF_REFL );
	free_vector(plot1, 0, MAX_NOF_REFL );


	

}
	


double  fact(i)
int     i;
{
        double f;
        
        f=i;
        i--;
        for ( ; i>1 ; i-- )
                f *= i;
        
        return(f);
}


double  findx( px )
double  px;
{

        int     i;
        double  res;


        for ( i=1 ; i < 4096 ; i++ )
                if ( px >= normtab[1][i-1] && px <= normtab[1][i] )
                {
                res = normtab[0][i-1] + (normtab[0][i]-normtab[0][i-1])*( (px-normtab[1][i-1]) / ( normtab[1][i]-normtab[1][i-1] ) );
                return( res );
                                }
        
        printf("PROBLEM in findx().\n");
	if ( px < normtab[1][0] )
		return( normtab[0][0] );
	else
		return( normtab[0][4095] );
		
	
}



int	get_grid( number )
float	number;
{
	int	pointer;
	
	if ( number < 0.0 )
		{
			printf("Negative number for grid size determination? Panic.\n\n");
			exit(1);
					}			
	if ( number < 1.0 )
		return(1);
	if ( number > 1024.0 )
		{
			printf("\n\n\nGrid size greater than 1024 ??? Abort.\n\n");
			exit(1);
					}
	pointer = 0;
	while ( number > good_numbers[pointer] )
		pointer++;
	
	return( good_numbers[pointer] );
}

	





/*****************************************************************************************************************************************/
/** 	 	**/
/*****************************************************************************************************************************************/
